/*
 * a12nd.2.c
 * Copyright (C) 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <a1-types.h>

int
x1f4_over_shuffle(struct a1_shuffle_type *shuffle_data, void **used)
{
    struct a1_instant_type *instant_data;

    instant_data = shuffle_data->instant_data;
    if (instant_data) {
	struct a1_trans18_type *trans18_data;

	trans18_data = (void *)
	    ((char *) instant_data
	     - offsetof(struct a1_trans18_type, r.instant));
	*used = trans18_data->i.used;
    } else {
	*used = NULL;
    }

    return 0;
}
