/*
 * af.x.c
 * Copyright (C) 2014, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <a1n.h>
#include <e4.h>
#include <e4n.h>
#include <ln.h>
#include <nt.h>

extern int x1f4_flat_lxmile(void *, void **);

static const struct x1f4_linetext_type linetext = {
/* *INDENT-OFF* */
    {
	"",
	NULL,
	X1f4_E4_VOID,
	NULL,
	0,
	0,
	0
    },
    NULL
/* *INDENT-ON* */
};

int
_x1f4_flat_effect(void *subtext, void **address)
{
    int status;
    void *data;

    data = *address;
    if (data) {
	unsigned flags;

	/*
	 * NOTES
	 *
	 * function not really doing what is expected of it, it does not
	 * restore *address to an initialized state
	 */

	flags = ((const struct x1f4_linetext_type *) data)->function.flags;

	if (flags & X1f4_E4_NODE_LINK) {
	    status = _x1f4_a1_flat_news(subtext, address);
	} else {
	    if (flags & X1f4_E4_NEWS_LINK) {
		status = _x1f4_e4_flat_news(subtext, address);
	    } else {
		if (flags & X1f4_E4_OVER_LINK) {
		    struct x1f4_leadnode_type *leadnode_data;
		    struct x1f4_nodetype_type *nodetype_data;

		    leadnode_data = data;
		    leadnode_data--;

		    nodetype_data = leadnode_data->link.nodetype_data;

		    status = x1f4_flat_lxmile(nodetype_data->context, address);
		    if (0) {
		    } else {
			/*
			 * at the very least, _flat_lxmile attempted to destroy
			 * the object
			 */
			*address = (void *) &linetext;
		    }
		} else {
		    status = 0;
		}
	    }
	}

	/*
	 * cannot reset *address.  fp variables need a definition attached.
	 */
#if 0
	*address = NULL;
#endif				/* 0 */
    } else {
	status = 0;
    }

    return status;
}
