/*
 * bqfv.9.c
 * Copyright (C) 2009-2012, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <bcount.h>
#include <bqfx-defs.h>
#include <bqfx-inter.h>
#include <bqfx-lines.h>
#include <bqfx-names.h>
#include <bqfx-types.h>
#include <xls.h>

#define __HALF_TRANSFER__		1

#define __FINE_EXCESS__			1
#define __FINE_SECOND__			2
#define __FINE_SELECT__			3
#define __FINE_TARGET__			4

#define __FINE_METHOD__			__FINE_EXCESS__

#define ____FINE_METHOD__		__FINE_METHOD__

#define __LOSE_DOUBLE__			1

#define __LOSE_METHOD__			__LOSE_DOUBLE__

#define __UNROLL_TRANSFER__		0

#define __HEAD_LEFT__			1

#define FINE_ERROR			(LAST_ERROR + 8)

#define false(e)			0

#define beta(___s, ___n) \
    (___s) = (char *) (___s) - ((___n) << 1)

#define cell(___s, ___n, ___t) \
    ((char *) (___s) - (___n) * (___t))

#define dana(___s, ___n) \
    (___s) = (char *) (___s) + ((___n) << 1)

#define life(___s, ___n) \
    ((char *) (___s) - (___n))

#define lola(___s, ___n) \
    ((char *) (___s) - ((___n) << 1))

#define posh(___s, ___n) \
    (___s) = (char *) (___s) - (___n)

#define road(___s, ___n) \
    ((char *) (___s) + ((___n) << 1))

#define rule(___s, ___n, ___t) \
    ((char *) (___s) + (___n) * (___t))

#define sans(___s, ___n) \
    ((char *) (___s) + (___n))

#define skip(___s, ___n) \
    (___s) = (char *) (___s) + (___n)

#define trap(___n, ___s)		((___n) + ((___s) << 2))

#define true(e)				1

#undef Q
#define Q(e)				((integral_q) (e))

#define bqfset(bqfset)			((struct bqfset_type *) (bqfset))

static int clip(void *, unsigned);
static int fine(void *, unsigned, void *);
static int lose(void *, unsigned, void *, void *, unsigned, unsigned);
static int miss(void *, void *, unsigned, unsigned);
static int shut(void *, unsigned, unsigned);

static int
clip(void *bqfset, unsigned size)
{
    int status;
    unsigned mind;
    void *node;

    node = bqfset(bqfset)->link_a.fpnews.node;

    mind = *(integral_q *) node;
    if (mind) {
	mind--;
	*((integral_q *) node) = mind;
	status = 0;
    } else {
	status = DECK_ERROR;
    }

    return status;
}


static int
fine(void *bqfset, unsigned size, void *node)
{
    int status;

    do {
	integral_q news;

	news = *(integral_q *) node;

	if (news & Q(1) << integral_q_last) {
	    status = 0;

	    *(integral_q *) node = news & ~(Q(1) << integral_q_last);

	    if (1) {
		break;
	    }
	} else {
	}
	{
	    integral_q slip;

	    slip = news & ~Lx55555555;
	    if (slip) {
		int (*move)(void *, void *, unsigned);
		void *fast;

		move = bqfset(bqfset)->link_f.move;

		status = 0;

		fast = rule(node, size, integral_q_bits - 2);

		if (news & Q(1) << (integral_q_bits - 3)) {
		    *(integral_q *) node =
			news & ~(Q(1) << (integral_q_bits - 3));
		    move(fast, life(fast, size), 1);
		} else {
		    if (0) {
		    } else {
#if ____FINE_METHOD__ == __FINE_SELECT__
#elif __FINE_METHOD__ == __FINE_EXCESS__
			integral_q last;
			unsigned copy = integral_q_bits - 2;

			last = slip << 2;
			if (1) {
			    size <<= 1;
			    for (; !(last & Q(15) << (integral_q_bits - 4));
				 last <<= 4) {
				void *side;

				side = (char *) fast - size;
				move(fast, side, 1);
				fast = (char *) side - size;
				move(side, fast, 1);

				copy -= 4;
			    }
			    if (!(last & Q(3) << (integral_q_bits - 2))) {
				void *side;

				side = (char *) fast - size;
				move(fast, side, 1);
				fast = side;

				copy -= 2;
			    }
			    size >>= 1;
			    {
				move(fast, (char *) fast - size, 1);
			    }

			    *(integral_q *) node = news ^ (Q(1) << (copy - 1));
			} else {
			}
#elif __FINE_METHOD__ == __FINE_SECOND__
#elif __FINE_METHOD__ == __FINE_TARGET__
#endif				/* ____FINE_METHOD__ == __FINE_SELECT__ */
		    }
		}
	    } else {
		*(integral_q *) node = news & ~(Q(1) << (integral_q_bits - 2));
		if (1) {
		    status = FINE_ERROR + integral_q_bits - 2;
		}
	    }
	}
    } while (0);

    return status;
}


static int
lose(void *bqfset, unsigned size, void *path, void *high, unsigned pass,
     unsigned rate)
{
    integral_q pipe;
    void *file, *node;
    int status;

    node = ZD(high, size)[pass];

    pipe = *(integral_q *) node;

    while (1) {
	file = ZD(node, size)[integral_q_last];

	if (rate) {
	    integral_q lane;

	    lane = *(integral_q *) file;

	    if (lane & ~Lx55555555) {
		high = node;

		node = file;

		pipe = lane;

		rate = rate - 1;
	    } else {
		void *club, *head;

		if (1) {
		    if (pipe & (Q(1) << integral_q_last)) {
			club = ZD(node, size)[integral_q_last - 1];
			head = HD(node, size, integral_q_last);
		    } else {
			if (1) {
			    club = ZD(node, size)[integral_q_last - 2];
			    head = HD(node, size, integral_q_last - 1);
			} else {
			}
		    }
		} else {
		}

		status = _libx1f4l2_zero_bqfset
		    (bqfset, path, &head, club, pipe, &node, &file);
		if (status == FREE_ERROR) {
		    break;
		} else {
		}

		path = head;

		high = node;

		node = file;

		pipe = *(integral_q *) file;

		rate = rate - 1;
	    }
	} else {
	    status = fine(bqfset, size, file);
	    if (status) {
		status = _libx1f4l2_mint_bqfset(bqfset, node, pipe);
	    }

	    break;
	}
    }

    return status;
}


static int
miss(void *bqfset, void *node, unsigned size, unsigned rate)
{
    int status;

    if (1) {
	unsigned mind;
	void *head;

	mind = *(integral_q *) node;

	if (1) {
	    head = rule(node, size, mind);
	} else {
	}

	do {
	    void *file;

	    file = MD(node, size)[mind];

	    if (*(integral_q *) file & ~Lx55555555) {
	    } else {
		status = _libx1f4l2_moon_bqfset
		    (bqfset, mind, node, MD(node, size)[mind - 1], &head, file,
		     rate);
		if (status) {
		    if (status < LAST_ERROR) {
			break;
		    } else {
			if (status ^ (LAST_ERROR + integral_q_bits)) {
			    status = shut(bqfset, size, rate);

			    break;
			} else {
			    mind--;

			    file = MD(node, size)[mind];
			}
		    }
		}
	    }

	    status = lose
		(bqfset, size, head, node, trap(mind, size), rate - 1);
	} while (0);
    }

    return status;
}


static int
shut(void *bqfset, unsigned size, unsigned rate)
{
    int status;
    void *node;

    node = bqfset(bqfset)->link_a.fpnews.node;

    if (rate ^ 1) {
	status = miss(bqfset, node, size, rate - 1);
    } else {
	unsigned pick;
	void *file;

	pick = *(integral_q *) node;

	file = MD(node, size)[pick];

	status = fine(bqfset, size, file);
	if (status) {
	    status = _libx1f4l2_hull_bqfset(bqfset, node);
	}
    }

    return status;
}


int
x1f4_slip_bqfset(void *bqfset)
{
    int status;
    unsigned rate, size;

    size = bqfset(bqfset)->link_a.fpnews.link_v.size;

    rate = bqfset(bqfset)->link_a.fpnews.link_v.rate;

    if (rate) {
	status = shut(bqfset, size, rate);
    } else {
	status = clip(bqfset, size);
    }

    return status;
}
