/*
 * bqfv.y.c
 * Copyright (C) 2009-2012, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <bcount.h>
#include <bqfx-defs.h>
#include <bqfx-inter.h>
#include <bqfx-lines.h>
#include <bqfx-names.h>
#include <bqfx-types.h>

#define __HALF_TRANSFER__		1

#define __SINGLE_MERGE__		1

#define __UNROLL_TRANSFER__		0

#define beta(___s, ___n) \
    (___s) = (char *) (___s) - ((___n) << 1)

#define cell(___s, ___n, ___t) \
    ((char *) (___s) - (___n) * (___t))

#define dana(___s, ___n) \
    (___s) = (char *) (___s) + ((___n) << 1)

#define life(___s, ___n) \
    ((char *) (___s) - (___n))

#define lola(___s, ___n) \
    ((char *) (___s) - ((___n) << 1))

#define posh(___s, ___n) \
    (___s) = (char *) (___s) - (___n)

#define road(___s, ___n) \
    ((char *) (___s) + ((___n) << 1))

#define rule(___s, ___n, ___t) \
    ((char *) (___s) + (___n) * (___t))

#define sans(___s, ___n) \
    ((char *) (___s) + (___n))

#define skip(___s, ___n) \
    (___s) = (char *) (___s) + (___n)

#define trap(___n, ___s)		((___n) + ((___s) << 2))

#define true(e)				1

#undef Q
#define Q(e)				((integral_q) (e))

#define bqfset(bqfset)			((struct bqfset_type *) (bqfset))

int
_libx1f4l2_hull_bqfset(void *bqfset, void *node)
{
    int (*move)(void *, void *, unsigned), status;
    integral_q last;
    unsigned deck, ever, mind, pick, size;
    void *club, *file;

    pick = *(integral_q *) node;

    mind = *(integral_q *) node;

    size = bqfset(bqfset)->link_a.fpnews.link_v.size;

    move = bqfset(bqfset)->link_f.move;

    status = 0;

    if (1) {
	club = MD(node, size)[pick - 1];
	last = *(integral_q *) club;
	l2_q_bitcount(deck, last);
    } else {
    }

    file = MD(node, size)[pick];

    if (half_integral_q_bits < deck) {
	if (0) {
	} else {
#if __HALF_TRANSFER__
	    if (1) {
		integral_q text;
		unsigned slip;
		void *fast, *side;

		fast = rule(file, size, integral_q_bits - 2);

		ever = (integral_q_bits - 4) >> 1;

# if __UNROLL_TRANSFER__
#  error
# else
		if (ever & 1) {
		    side = lola(fast, size);
		    move(fast, side, 1);
		    fast = side;
		}
		ever >>= 1;
		for (; ever; ever--) {
		    side = lola(fast, size);
		    move(fast, side, 1);
		    fast = lola(side, size);
		    move(side, fast, 1);
		}
# endif				/* __UNROLL_TRANSFER__ */

		fast = file;

		deck -= half_integral_q_bits;

		if (deck < 4) {
		    deck = 1;

		    *(integral_q *) fast = Lx55555555;

		    dana(fast, size);
		} else {
		    deck &= ~1;

		    *(integral_q *) fast = Lx55555555
			| ((Q(1) << (deck - 2)) - 1);

		    if (deck < 8) {
			deck >>= 1;

			fast = rule(fast, size, deck);
		    } else {
			fast = rule(fast, size, deck - 3);

			side = life(fast, size);

			deck >>= 1;

			ever = deck - 3;
			for (; ever; ever--) {
			    move(fast, side, 1);
			    beta(side, size);
			    posh(fast, size);
			}
		    }
		}

		move(fast, rule(node, size, pick), 1);

		posh(fast, size);

		deck--;

		text = *(integral_q *) club;

		side = rule(club, size, integral_q_bits);

		while (deck & ~1) {
		    if (text & Q(1) << integral_q_last) {
			beta(side, size);
			posh(fast, size);
			move(fast, side, 2);
			posh(fast, size);

			deck -= 2;
		    } else {
			deck--;

			beta(side, size);
			move(fast, side, 1);
			posh(fast, size);
		    }

		    text <<= 2;
		}
		if (deck) {
		    if (text & Q(1) << integral_q_last) {
			posh(side, size);
			move(fast, side, 1);
			posh(side, size);
			move(rule(node, size, pick), side, 1);

			deck = 0;
		    } else {
			beta(side, size);
			move(fast, side, 1);
		    }

		    text <<= 2;
		} else {
		    deck = 1;
		}
		slip = integral_q_bits - 2;
		if (deck) {
		    if (text & Q(1) << integral_q_last) {
			posh(side, size);
			move(rule(node, size, pick), side, 1);

			posh(side, size);

			fast = rule(club, size, integral_q_bits - 2);

			text <<= 1;
		    } else {
			beta(side, size);
			move(rule(node, size, pick), side, 1);

			posh(side, size);

			fast = rule(club, size, integral_q_bits - 2);

			text <<= 2;

			if (side < fast) {
			    if (text
				& Q(1) << integral_q_last) {
				move(fast, side, 1);
				beta(fast, size);
				slip -= 2;
			    }

			    posh(side, size);

			    text <<= 1;
			}
		    }
		} else {
		    posh(side, size);

		    fast = rule(club, size, integral_q_bits - 2);

		    if (side < fast) {
			if (text & Q(1) << integral_q_last) {
			    move(fast, side, 1);
			    beta(fast, size);
			    slip -= 2;
			}

			posh(side, size);

			text <<= 1;
		    }
		}
		while (side < fast) {
		    if (text & Q(1) << (integral_q_bits - 2)) {
			move(fast, side, 1);
			beta(fast, size);
			posh(side, size);
			move(fast, side, 1);
			beta(fast, size);
			posh(side, size);
			slip -= 4;
		    } else {
			move(fast, side, 1);
			beta(fast, size);
			beta(side, size);
			slip -= 2;
		    }

		    text <<= 2;
		}

		*(integral_q *) club = Lx55555555
		    | text >> (integral_q_last - slip);
	    }
#else
# error
#endif				/* __HALF_TRANSFER__ */
	}
    } else {
	do {
	    void *fast;
#if __SINGLE_MERGE__
	    void *side;
#else
#endif				/* __SINGLE_MERGE__ */
	    void *tier = NULL;

	    if (mind ^ 1) {
	    } else {
		status = _libx1f4l2_fold_bqfset
		    (bqfset, club, file, tier, pick,
		     integral_q_bits - 2, node);
		if (1) {
		    break;
		}
	    }

#if __SINGLE_MERGE__
	    *(integral_q *) file = ~Q(2);

	    side = rule(file, size, integral_q_bits - 4);

	    fast = rule(file, size, integral_q_last);

	    deck = (integral_q_bits - 2 - 2) >> 1;

	    ever = deck >> 1;
	    for (; ever; ever--) {
		move(fast, side, 1);
		posh(fast, size);
		beta(side, size);
		move(fast, side, 1);
		posh(fast, size);
		beta(side, size);
	    }
	    {
		move(fast, rule(node, size, mind), 1);
		posh(fast, size);
	    }

	    side = rule(club, size, integral_q_bits - 2);

	    deck = (integral_q_bits - 2) >> 1;

	    ever = deck >> 1;
	    for (; ever; ever--) {
		move(fast, side, 1);
		posh(fast, size);
		beta(side, size);
		move(fast, side, 1);
		posh(fast, size);
		beta(side, size);
	    }
	    if (deck & 1) {
		move(fast, side, 1);
		posh(fast, size);
		beta(side, size);
	    }

	    if (1) {
		void **trap;

		mind--;

		trap = MD(node, size) + mind;

		memmove(trap, trap + 1, sizeof(void *));

		*(integral_q *) node = mind;

		status = bqfset(bqfset)->link_m.free
		    (bqfset(bqfset)->link_m.data, club);
		if (status) {
		    status = FREE_ERROR;
		}
	    }
#else
	    if (1) {
		if (0) {
		} else {
		    unsigned copy = integral_q_bits - 2;

		    _libx1f4l2_gray_bqfset
			(bqfset, &club, node, &pick, &file, &tier, &copy);
		    if (tier) {
		    } else {
			break;
		    }
		}
	    } else {
	    }

	    if (1) {
		fast = file;

		fast = rule(fast, size, integral_q_bits - 2);

		if (0) {
		} else {
		    deck = (half_integral_q_bits - 2) >> 1;

# if __UNROLL_TRANSFER__
#  error
# else
		    for (; deck; deck--) {
			move(fast, (char *) fast - (size << 1), 1);
			beta(fast, size);
		    }
# endif				/* __UNROLL_TRANSFER__ */
		}
	    }

	    {
		void *side;

		fast = club;

		*(integral_q *) club =
		    Lxdddddddd ^ Q(1) << integral_q_last;

		if (0) {
		} else {
		    fast = rule(fast, size, 4);

		    side = life(fast, size);

		    move(side, fast, 1);
		    dana(fast, size);
		    skip(side, size);
		}

		deck = (integral_q_bits - 6) / 6;
		for (; deck; deck--) {
		    move(side, fast, 1);
		    dana(fast, size);
		    dana(side, size);
		    move(side, fast, 1);
		    dana(fast, size);
		    skip(side, size);
		    move(side, fast, 1);
		    dana(fast, size);
		    skip(side, size);
		}

		if (0) {
		} else {
		    if (half_integral_q_bits % 3 ^ 2) {
			move(side, fast, 1);

			fast = file;

			dana(fast, size);
			dana(side, size);
			move(side, rule(node, size, pick), 1);
			skip(side, size);
			move(side, fast, 1);
			skip(side, size);
		    } else {
			move(side, fast, 1);
			dana(fast, size);
			dana(side, size);
			move(side, fast, 1);

			fast = file;

			skip(side, size);
			move(side, rule(node, size, pick), 1);
			skip(side, size);
		    }
		}

		deck = integral_q_bits / 4 - integral_q_bits / 6 - 2;
		for (; deck; deck--) {
		    dana(fast, size);
		    move(side, fast, 1);
		    dana(side, size);
		    dana(fast, size);
		    move(side, fast, 1);
		    skip(side, size);
		    dana(fast, size);
		    move(side, fast, 1);
		    skip(side, size);
		}

		{
		    dana(fast, size);
		    move(side, fast, 1);
		    dana(side, size);
		    dana(fast, size);
		    move(side, fast, 1);
		}

		fast = rule(tier, size, integral_q_bits);

		side = fast;

		deck = integral_q_bits / 6;
		for (; deck; deck--) {
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    beta(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		}

		if (0) {
		} else {
		    if (half_integral_q_bits % 3 ^ 2) {
			fast = rule(file, size, integral_q_bits - 2);

			posh(side, size);
			move(side, rule(node, size, pick + 1),
			     1);
			posh(side, size);
			move(side, fast, 1);
			beta(side, size);
			beta(fast, size);
			move(side, fast, 1);
		    } else {
			posh(side, size);
			beta(fast, size);
			move(side, fast, 1);

			fast = rule(file, size, integral_q_bits - 2);

			posh(side, size);
			move(side, rule(node, size, pick + 1),
			     1);
			beta(side, size);
			move(side, fast, 1);
		    }
		}

		deck = integral_q_bits / 4 - integral_q_bits / 6 - 2;
		for (; deck; deck--) {
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    beta(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		}

		{
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		}

		*(integral_q *) tier = Lxdddddddd;
	    }

	    if (1) {
		void *side, **trap;

		trap = MD(node, size) + pick;

		memmove(trap, trap + 1, (mind - pick) * sizeof(void *));

		side = rule(node, size, pick);

		move(side, cell(fast, size, 4), 1);

		skip(side, size);

		move(side, sans(side, size), mind - pick);

		*(integral_q *) node = mind - 1;

		status = bqfset(bqfset)->link_m.free
		    (bqfset(bqfset)->link_m.data, file);
		if (status) {
		    status = FREE_ERROR;
		}
	    }
#endif				/* __SINGLE_MERGE__ */
	} while (0);
    }

    return status;
}
