/*
 * e4ll.e.c
 * Copyright (C) 2008-2012, 2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4ll-defs.h>
#include <e4ll-types.h>

#define e4less(e4less) \
    ((struct e4less_type *) (e4less))

int
x1f4_trap_e4ll(void *e4less)
{
    int status;
    struct e4node_type *e4node_data;

    e4node_data = e4less(e4less)->link_c.node;
    if (e4node_data) {
	int (*deck)(void **);

	deck = e4less(e4less)->link_a.deck;

	do {
	    void *link;

	    link = e4node_data->link;
	    if (link) {
		status = deck(&link);
		if (status) {
		    status = DECK_ERROR;
		    break;
		}
	    }

	    e4node_data = e4node_data->e4node_data;
	} while (e4node_data);
    } else {
	status = 0;
    }

    return status;
}
