/*
 * lxcall-e.m.c
 * Copyright (C) 2011-2014, 2016, 2017, 2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <copy.h>
#include <e4.h>
#include <fd.h>
#include <integral_q.h>
#include <lxcall-defs.h>
#include <lxcall-inter.h>
#include <lxcall-types.h>
#include <lxcast.h>

static int rule_line(struct center_type *, const struct x1f4_function_type *,
		     unsigned,
		     unsigned, const struct x1f4_function_type *, unsigned,
		     unsigned, unsigned, unsigned, int,
		     struct fxdata_type *, struct x1f4_dxcast_type *);

static int
rule_line(struct center_type *center_data,
	  const struct x1f4_function_type *function_text,
	  unsigned o, unsigned post,
	  const struct x1f4_function_type *function_data, unsigned offset,
	  unsigned h, unsigned flat, unsigned mind, int lock,
	  struct fxdata_type *missed_data,
	  struct x1f4_dxcast_type *dxcast_slip)
{
    const int *data;
    int delete, status = 0;
    const int *text;
    void **track;

    data = function_data->args + offset;
    text = function_text->args;

    track = *center_data->input;

    h += offset;

    delete = lock < o ? 1 : 0;
    for (; delete; delete--) {
	int name, type;

	track += lock;

	data += lock;
	text += lock;

	name = *data;
	type = *text;
	if (type == X1f4_E4_SLIP) {
	    type = name;
	}

	if (name ^ type) {
	    status = _libx1f4i0_lxcall_rule_fare
		(center_data, name, type, track, &missed_data, &dxcast_slip);
	    if (status) {
		break;
	    }
	} else {
	    if (post) {
		if (mind) {
		    unsigned pass;

		    pass = text[o];
		    if ((data[h] ^ pass) & X1f4_E4_POST_XSET) {
			if (pass & X1f4_E4_POST_XSET) {
			} else {
			    copy_miss(missed_data, name, *track);
			    *track = missed_data;
			    missed_data++;
			}
		    }
		}
	    } else {
		if (mind) {
		    if (data[h] & X1f4_E4_POST_XSET) {
			copy_miss(missed_data, name, *track);
			*track = missed_data;
			missed_data++;
		    }
		}
	    }
	}
    }
    if (delete) {
    } else {
	if (!mind || function_text->flags & X1f4_E4_LINK_PASS || lock < o) {
	} else {
	    track += lock;
	    data += lock;
	    if (1) {
		if (data[h] & X1f4_E4_POST_XSET) {
		    copy_miss(missed_data, *data, *track);
		    *track = missed_data;
		}
	    }
	}
    }

    return status;
}


/*
 * offset assumed 0.
 * POST_DATA assumed.
 */
int
_libx1f4i0_lxcall_even_mark(struct center_type *center_data,
			    const struct x1f4_function_type *function_text,
			    const struct x1f4_function_type *function_data,
			    unsigned offset, unsigned bits,
			    int lock, struct fxdata_type *fxdata_data,
			    struct x1f4_dxcast_type *dxcast_data)
{
    int delete, status = 0;
    unsigned h, o;

    h = function_data->count;
    o = function_text->count;

    delete = h - o - offset;
    if (0) {
    } else {
	unsigned flat = 0, mind = 0, post, x = 0;
	const int *data, *text;

	data = function_data->args + offset;
	text = function_text->args;

	mind = function_data->flags & X1f4_E4_POST_TYPE;
	post = function_text->flags & X1f4_E4_POST_TYPE;

	delete = lock < o ? 1 : 0;
	for (; delete; delete--) {
	    int name, type;

	    data += lock;
	    text += lock;

	    name = *data;
	    type = *text;
	    status = _libx1f4i0_lxcall_even_fare
		(center_data, 0, h, o, delete,
		 data, name, mind, text, type, post, 3, &flat, &x);
	    if (status) {
		break;
	    }
	}
	if (delete) {
	} else {
	    /*
	     * why is this done?  it seems copying these arguments is not
	     * required.
	     */
	    if (!mind || function_text->flags & X1f4_E4_LINK_PASS
		|| lock < o) {
	    } else {
		data += lock;
		if (1) {
		    if (data[h] & X1f4_E4_POST_XSET) {
			flat++;
		    }
		}
	    }

	    if (flat) {
		h -= offset;

		if (0) {
		} else {
		    status = rule_line
			(center_data, function_text, o, post, function_data,
			 offset, h, flat, mind, lock, fxdata_data,
			 dxcast_data);
		}
	    }
	}
    }

    return status;
}
