/*
 * lxcall-w.s.c
 * Copyright (C) 2008-2016, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxcall-types.h>
#include <nt.h>

void
_libx1f4i0_lxcall_lock_wmix(v_case_args_____1, int norm, int call,
			    struct x1f4_ftsl_type **ftsl, void *intrinsic,
			    int (*const *rate)(void *, void *, void **))
{
    int *line, type;
    unsigned flags;

    flags = nodetype_data->flags;

    type = nodetype_data->code;

    line = *args;

    linetext_data->function.args = line;

    *line++ = type;
    *line++ = norm;
    *line++ = call;
    *line++ = call;
    if (flags & X1f4_LX_FLAT_REFLEX) {
	*line++ = 0;
    } else {
	*line++ = X1f4_E4_POST_XSET;
    }
    {
	*line++ = 0;
	*line++ = 0;
	*line++ = X1f4_E4_POST_XSET;
    }

    *args = line;

    if (nodetype_data->lead) {
	linetext_data->function.function = rate[5];
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = rate[4];
	} else {
	    linetext_data->context = intrinsic;

	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = rate[3];
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function = rate[2];
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function = rate[1];
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function = rate[0];
			} else {
			}
		    }
		}
	    }
	}
    }

    if (1) {
	struct x1f4_ftsl_type *ftsl_data;

	ftsl_data = *ftsl;
	ftsl_data->linetext_data = linetext_data;
	ftsl_data->type = type;
	*ftsl = ftsl_data + 1;
    }
}
