/*
 * lxcase-e.t.c
 * Copyright (C) 2010-2011, 2016, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <dt.h>
#include <ix.h>
#include <lxcase-inter.h>
#include <mxdeck.h>

#define lxcase(port) \
    ((struct lxcase_type *) (port))

int
x1f4_wrap_lxcase(void *lxcase, struct x1f4_indexset_type *indexset_data)
{
    const char *name;
    const struct x1f4_datatype_type *datatype_data;

    datatype_data = indexset_data->datatype_set.datatype_data;

    lxcase(lxcase)->link_l.date = NULL;

    name = datatype_data->name;
    while (name) {
	if (datatype_data->size == 4) {
	    int a, b, c, d;

	    a = name[0];
	    b = name[1];
	    c = name[2];
	    d = name[3];

	    if (a == 'd' && b == 'a' && c == 't' && d == 'e') {
		lxcase(lxcase)->link_l.date = (void *) datatype_data;
	    } else {
	    }
	}

	datatype_data++;

	name = datatype_data->name;
    }

    return 0;
}
