/*
 * lxdash-a.0.c
 * Copyright (C) 2008-2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * TODO
 *
 * merge copy_line into fast_line
 */

#include <stddef.h>
#include <string.h>

#include <af.h>
#include <d_fset.h>
#include <e4-m.0.h>
#include <e4.h>
#include <e4fine.h>
#include <lxcall.h>
#include <lxdash-defs.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>
#include <lxnext.h>
#include <mxdeck.h>

#define MAKE_DOUBLE(a, b)		a b
#define MAKE_SINGLE(a, b)		a

#define l_e_type_post			3

#define l_ec_set_post			3

#define l_g_type_post			3

#define l_gc_set_post			3

#define l_j_type_post			3

#define l_o_type_post			3

#define lbe_type_post			2

#define lbg_type_post			2

#define lfe_type_post			2

#define lfg_type_post			2

#define true(e)				1

#define part(screen) \
    ((struct depart_type *) (screen))
#define screen(screen) \
    ((struct screen_type *) ((struct depart_type *) (screen))->screen_data)

#define fb_size() \
    (sizeof(side_o) / sizeof(struct x1f4_operator_type))
#define fp_size() \
    (sizeof(side_u) / sizeof(struct x1f4_operator_type))

/*
 * all the types + 6 arithmetics (3 types x 2 ops) + one generic
 */
#define fi_size(___p)			((___p) + 7)

#define fm_size(none) \
    sizeof(struct lxmiss_type)

extern const struct x1f4_eelookup_type _x1f4_type_lookup;

static int init_line(struct lxdash_type *, unsigned,
		     const struct screen_type *);
static int line_data(struct lxdash_type *, unsigned,
		     const struct depart_type *, void *, void *, void **,
		     void **);
static int line_line(struct lxdash_type *, unsigned,
		     const struct screen_type *);
static int line_plus(struct lxdash_type *);
static int line_rail(void *, unsigned, struct x1f4_operator_type *,
		     struct x1f4_2ndscope_type *, struct x1f4_linetext_type *);
static int line_sail(struct lxdash_type *, const struct screen_type *,
		     struct lxtext_type *, const struct lxtype_type *, void **,
		     void **);
static int line_text(struct lxdash_type *, unsigned,
		     const struct depart_type *, void *, void **, void **);
static int link_line(struct lxdash_type *, unsigned,
		     const struct screen_type *);
static int part_text(struct lxdash_type *, unsigned,
		     const struct depart_type *, struct x1f4_linetext_type **,
		     void **, unsigned, const struct line_type *);
static int pick_miss(unsigned *, unsigned *, unsigned *, unsigned *, unsigned,
		     const struct screen_type *);

static void _slmmx00x(u_case_args_____0);
static void bo_lmm00x(u_case_args_____0);
static void bo_slmx00(u_case_args_____0);
static void bo_slmx0x(u_case_args_____0);
static void bo_slmy00(u_case_args_____0);
static void born_lm0x(u_case_args_____0);
static void born_n_lm(v_case_args_____0);
static void born_sly0(u_case_args_____0);
static void borne_lcm(u_case_args_____0);
static void borne_lmm(u_case_args_____0);
static void borne_lms(u_case_args_____0);
static void borneo__l(u_case_args_____0);
static void borneo_l_(u_case_args_____0);
static void borneo_lb(u_case_args_____0);
static void borneo_lm(u_case_args_____0);
static void last_amix(v_case_args_____0);
static void last_smix(v_case_args_____0);
static void line_amix(v_case_args_____0);
static void line_bfar(v_case_args_____0);
static void line_cfar(v_case_args_____0);
static void line_dfar(v_case_args_____0);
static void line_emix(v_case_args_____0);
static void line_epix(v_case_args_____0);
static void line_esix(v_case_args_____0);
static void line_evix(v_case_args_____0);
static void line_fmix(v_case_args_____0);
static void line_gmix(v_case_args_____0);
static void line_gpix(v_case_args_____0);
static void line_gsix(v_case_args_____0);
static void line_gvix(v_case_args_____0);
static void line_jmix(v_case_args_____0);
static void line_kway(v_case_args_____0);
static void line_lfar(v_case_args_____0);
static void line_nset(u_case_args_____0);
static void line_omix(v_case_args_____0);
static void line_pmix(v_case_args_____0);
static void line_qmix(v_case_args_____0);
static void line_qpix(v_case_args_____0);
static void line_qsix(v_case_args_____0);
static void line_qvix(v_case_args_____0);
static void line_rmix(v_case_args_____0);
static void line_smap(v_case_args_____0);
static void line_sset(u_case_args_____0);
static void line_wmap(u_case_args_____0);
static void line_xmix(v_case_args_____0);
static void line_xpix(v_case_args_____0);
static void line_xsix(v_case_args_____0);
static void line_xvix(v_case_args_____0);
static void lock_gmix(v_case_args_____0);
static void lock_lmix(v_case_args_____0);
static void lock_omix(v_case_args_____0);
static void lock_umix(v_case_args_____0);
static void rail_plus(struct x1f4_linetext_type *, struct lxdash_type *,
		      const struct x1f4_operator_type *);
static void themed__l(u_case_args_____0);
static void themed_ll(u_case_args_____0);
static void themed_lm(u_case_args_____0);

static const char fi_addf[] = "i_add", fi_bindf[] = "i_bind", fi_casef[] =
    "i_case", fi_chance1f[] = "i_chance1", fi_dockf[] = "i_dock", fi_fixf[] =
    "i_fix", fi_getf[] = "i_get",
    fi_linkf[] = "i_link", fi_pickf[] = "i_pick", fi_putf[] = "i_put",
    fi_queryf[] = "i_query", fi_replacef[] = "i_replace", fi_setf[] = "i_set",
    fi_sizef[] = "i_size", fi_yankf[] = "i_yank", fis_greaterf[] =
    "is_greater", fis_lessf[] = "is_less", fis_lowerf[] = "is_lower",
    fis_upperf[] = "is_upper", *const side_f[] = {
/* *INDENT-OFF* */
    fi_setf,
    fi_queryf,
    fi_chance1f
/* *INDENT-ON* */
}, *const side_l[] = {
/* *INDENT-OFF* */
    fi_sizef
/* *INDENT-ON* */
};
static int (*const rate_0vix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_a_break_b,
    _libx1f4i0_lxdash_a_break_m,
    _libx1f4i0_lxdash_a_break_r
/* *INDENT-ON* */
}, (*const rate_amix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_a_class_b,
    _libx1f4i0_lxdash_a_class_m,
    _libx1f4i0_lxdash_a_class_r,
    _libx1f4i0_lxdash_a_class_t,
    _libx1f4i0_lxdash_a_class_u,
    _libx1f4i0_lxdash_a_class_v
/* *INDENT-ON* */
}, (*const rate_emix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_e_class_b,
    _libx1f4i0_lxdash_e_class_m,
    _libx1f4i0_lxdash_e_class_r,
    _libx1f4i0_lxdash_e_class_t,
    _libx1f4i0_lxdash_e_class_u,
    _libx1f4i0_lxdash_e_class_v
/* *INDENT-ON* */
}, (*const rate_epix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_e0class_b,
    _libx1f4i0_lxdash_e0class_m,
    _libx1f4i0_lxdash_e0class_r,
    _libx1f4i0_lxdash_e0class_t,
    _libx1f4i0_lxdash_ebclass_u,
    _libx1f4i0_lxdash_ebclass_v
/* *INDENT-ON* */
}, (*const rate_esix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_e0class_b,
    _libx1f4i0_lxdash_e0class_m,
    _libx1f4i0_lxdash_e0class_r,
    _libx1f4i0_lxdash_e0class_t,
    _libx1f4i0_lxdash_efclass_u,
    _libx1f4i0_lxdash_efclass_v
/* *INDENT-ON* */
}, (*const rate_evix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_e_press_b,
    _libx1f4i0_lxdash_e_press_m,
    _libx1f4i0_lxdash_e_press_r,
    _libx1f4i0_lxdash_e_press_t,
    _libx1f4i0_lxdash_e_class_u,
    _libx1f4i0_lxdash_e_press_v
/* *INDENT-ON* */
}, (*const rate_fmix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_f_class_b,
    _libx1f4i0_lxdash_f_class_m,
    _libx1f4i0_lxdash_f_class_r,
    _libx1f4i0_lxdash_f_class_t,
    _libx1f4i0_lxdash_f_class_u,
    _libx1f4i0_lxdash_f_class_v
/* *INDENT-ON* */
}, (*const rate_gmix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_g_class_b,
    _libx1f4i0_lxdash_g_class_m,
    _libx1f4i0_lxdash_g_class_r,
    _libx1f4i0_lxdash_g_class_t,
    _libx1f4i0_lxdash_g_class_u,
    _libx1f4i0_lxdash_g_class_v
/* *INDENT-ON* */
}, (*const rate_gpix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_g0class_b,
    _libx1f4i0_lxdash_g0class_m,
    _libx1f4i0_lxdash_g0class_r,
    _libx1f4i0_lxdash_g0class_t,
    _libx1f4i0_lxdash_gbclass_u,
    _libx1f4i0_lxdash_gbclass_v
/* *INDENT-ON* */
}, (*const rate_gsix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_g0class_b,
    _libx1f4i0_lxdash_g0class_m,
    _libx1f4i0_lxdash_g0class_r,
    _libx1f4i0_lxdash_g0class_t,
    _libx1f4i0_lxdash_gfclass_u,
    _libx1f4i0_lxdash_gfclass_v
/* *INDENT-ON* */
}, (*const rate_gvix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_g_press_b,
    _libx1f4i0_lxdash_g_press_m,
    _libx1f4i0_lxdash_g_press_r,
    _libx1f4i0_lxdash_g_press_t,
    _libx1f4i0_lxdash_g_class_u,
    _libx1f4i0_lxdash_g_press_v
/* *INDENT-ON* */
}, (*const rate_jmix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_j_class_b,
    _libx1f4i0_lxdash_j_class_m,
    _libx1f4i0_lxdash_j_class_r,
    _libx1f4i0_lxdash_j_class_t,
    _libx1f4i0_lxdash_j_class_u,
    _libx1f4i0_lxdash_j_class_v
/* *INDENT-ON* */
}, (*const rate_omix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_o_class_b,
    _libx1f4i0_lxdash_o_class_m,
    _libx1f4i0_lxdash_o_class_r,
    _libx1f4i0_lxdash_o_class_t,
    _libx1f4i0_lxdash_o_class_u,
    _libx1f4i0_lxdash_o_class_v
/* *INDENT-ON* */
}, (*const rate_pmix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_p_class_b,
    _libx1f4i0_lxdash_p_class_m,
    _libx1f4i0_lxdash_p_class_r,
    _libx1f4i0_lxdash_p_class_t,
    _libx1f4i0_lxdash_p_class_u,
    _libx1f4i0_lxdash_p_class_v
/* *INDENT-ON* */
}, (*const rate_qmix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_q_class_b,
    _libx1f4i0_lxdash_q_class_m,
    _libx1f4i0_lxdash_q_class_r,
    _libx1f4i0_lxdash_q_class_t,
    _libx1f4i0_lxdash_q_class_u,
    _libx1f4i0_lxdash_q_class_v
/* *INDENT-ON* */
}, (*const rate_qpix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_q0class_b,
    _libx1f4i0_lxdash_q0class_m,
    _libx1f4i0_lxdash_q0class_r,
    _libx1f4i0_lxdash_q0class_t,
    _libx1f4i0_lxdash_qbclass_u,
    _libx1f4i0_lxdash_qbclass_v
/* *INDENT-ON* */
}, (*const rate_qsix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_q0class_b,
    _libx1f4i0_lxdash_q0class_m,
    _libx1f4i0_lxdash_q0class_r,
    _libx1f4i0_lxdash_q0class_t,
    _libx1f4i0_lxdash_qfclass_u,
    _libx1f4i0_lxdash_qfclass_v
/* *INDENT-ON* */
}, (*const rate_qvix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_q_press_b,
    _libx1f4i0_lxdash_q_press_m,
    _libx1f4i0_lxdash_q_press_r,
    _libx1f4i0_lxdash_q_press_t,
    _libx1f4i0_lxdash_q_class_u,
    _libx1f4i0_lxdash_q_press_v
/* *INDENT-ON* */
}, (*const rate_rmix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_r_class_b,
    _libx1f4i0_lxdash_r_class_m,
    _libx1f4i0_lxdash_r_class_r,
    _libx1f4i0_lxdash_r_class_t,
    _libx1f4i0_lxdash_r_class_u,
    _libx1f4i0_lxdash_r_class_v
/* *INDENT-ON* */
}, (*const rate_xmix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_x_class_b,
    _libx1f4i0_lxdash_x_class_m,
    _libx1f4i0_lxdash_x_class_r,
    _libx1f4i0_lxdash_x_class_t,
    _libx1f4i0_lxdash_x_class_u,
    _libx1f4i0_lxdash_x_class_v
/* *INDENT-ON* */
}, (*const rate_xpix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_x0class_b,
    _libx1f4i0_lxdash_x0class_m,
    _libx1f4i0_lxdash_x0class_r,
    _libx1f4i0_lxdash_x0class_t,
    _libx1f4i0_lxdash_xbclass_u,
    _libx1f4i0_lxdash_xbclass_v
/* *INDENT-ON* */
}, (*const rate_xsix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_x0class_b,
    _libx1f4i0_lxdash_x0class_m,
    _libx1f4i0_lxdash_x0class_r,
    _libx1f4i0_lxdash_x0class_t,
    _libx1f4i0_lxdash_xfclass_u,
    _libx1f4i0_lxdash_xfclass_v
/* *INDENT-ON* */
}, (*const rate_xvix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_x_press_b,
    _libx1f4i0_lxdash_x_press_m,
    _libx1f4i0_lxdash_x_press_r,
    _libx1f4i0_lxdash_x_press_t,
    _libx1f4i0_lxdash_x_class_u,
    _libx1f4i0_lxdash_x_press_v
/* *INDENT-ON* */
}, (*const turn_gmix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_0_point_b,
    _libx1f4i0_lxdash_0_point_m,
    _libx1f4i0_lxdash_0_point_r,
    _libx1f4i0_lxdash_0_point_t,
    _libx1f4i0_lxdash_g_point_u,
    _libx1f4i0_lxdash_g_point_v
/* *INDENT-ON* */
}, (*const turn_lmix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_0_point_b,
    _libx1f4i0_lxdash_0_point_m,
    _libx1f4i0_lxdash_0_point_r,
    _libx1f4i0_lxdash_0_point_t,
    _libx1f4i0_lxdash_l_point_u,
    _libx1f4i0_lxdash_l_point_v
/* *INDENT-ON* */
}, (*const turn_omix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_0_point_b,
    _libx1f4i0_lxdash_0_point_m,
    _libx1f4i0_lxdash_0_point_r,
    _libx1f4i0_lxdash_0_point_t,
    _libx1f4i0_lxdash_o_point_u,
    _libx1f4i0_lxdash_o_point_v
/* *INDENT-ON* */
}, (*const turn_umix[])(void *, void *, void **) = {
/* *INDENT-OFF* */
    _libx1f4i0_lxdash_0_point_b,
    _libx1f4i0_lxdash_0_point_m,
    _libx1f4i0_lxdash_0_point_r,
    _libx1f4i0_lxdash_0_point_t,
    _libx1f4i0_lxdash_u_point_u,
    _libx1f4i0_lxdash_u_point_v
/* *INDENT-ON* */
};
static const struct line_type auto_line[] = {
/* *INDENT-OFF* */
#define r_express_count			0
    {	{	"i_express",
		_libx1f4i0_lxdash_e_centric,	0,
		NULL,				r_express_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_SIDE_LIST
		| X1f4_E4_TEXT_LINK,
						9		},
	borneo_l_,							},
#define r_express_reach			(0 + r_express_count)
#define r_fit_count			1
    {	{	"i_fit",
		_libx1f4i0_lxdash_f_centric,	0,
		NULL,				r_fit_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_SIDE_LIST
		| X1f4_E4_TEXT_LINK,		5		},
	themed__l,							},
#define r_fit_reach			(r_express_reach + r_fit_count)
#define r_get_count			3
    {	{	fi_getf,
		_libx1f4i0_lxdash_g_derived,	X1f4_E4_CASE,
		NULL,				r_get_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						5		},
	bo_slmy00,							},
#define r_get_reach			(r_fit_reach + (r_get_count << 1))
#define r_jack_count			3
    {	{	"i_jack",
		_libx1f4i0_lxdash_j_derived,	X1f4_E4_MODE,
		NULL,				r_jack_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						6		},
	bo_slmx00,							},
#define r_jack_reach			(r_get_reach + (r_jack_count << 1))
#define r_new_count			1
    {	{	"i_new",
		_libx1f4i0_lxdash_n_forward,	X1f4_E4_VOID,
		NULL,				r_new_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		5		},
	line_nset,							},
#define r_new_reach			(r_jack_reach + (r_new_count << 1))
#define r_over_count			3
    {	{	"i_over",
		_libx1f4i0_lxdash_o_derived,	X1f4_E4_MODE,
		NULL,				r_over_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						6		},
	bo_slmx00,							},
#define r_over_reach			(r_new_reach + (r_over_count << 1))
#define r_render_count			0
    {	{	"i_render",
		_libx1f4i0_lxdash_r_centric,	0,
		NULL,				r_render_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_SIDE_LIST
		| X1f4_E4_TEXT_LINK,
						8		},
	borneo_l_,							},
#define r_render_reach			(r_over_reach + r_render_count)
#define r_tie_count			1
    {	{	"i_tie",
		_libx1f4i0_lxdash_t_centric,	0,
		NULL,				r_tie_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_SIDE_LIST
		| X1f4_E4_TEXT_LINK,
						5		},
	themed__l,							},
#define r_tie_reach			(r_render_reach + r_tie_count)
#define r_ucall_count			3
    {	{	"i_ucall",
		_libx1f4i0_lxdash_u_pending,	X1f4_E4_VOID,
		NULL,				r_ucall_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS
		| X1f4_E4_SIDE_LIST | X1f4_E4_TEXT_LINK
		| X1f4_E4_WALK_LINK,
						7		},
	borne_lcm,							},
#define r_ucall_reach			(r_tie_reach + r_ucall_count)
#define r_vcall_count			3
    {	{	"i_vcall",
		_libx1f4i0_lxdash_v_pending,	X1f4_E4_VOID,
		NULL,				r_vcall_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS
		| X1f4_E4_SIDE_LIST | X1f4_E4_TEXT_LINK
		| X1f4_E4_WALK_LINK,
						7		},
	borne_lcm,							},
#define r_vcall_reach			(r_ucall_reach + r_vcall_count)
#define r_wcall_count			4
    {	{	"i_wcall",
		_libx1f4i0_lxdash_w_pending,	X1f4_E4_VOID,
		NULL,				r_wcall_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS
		| X1f4_E4_SIDE_LIST | X1f4_E4_TEXT_LINK
		| X1f4_E4_WALK_LINK,
						7		},
	line_wmap,							},
#define r_wcall_reach			(r_vcall_reach + r_wcall_count)
#define r_yank_count			3
    {	{	fi_yankf,
		_libx1f4i0_lxdash_y_derived,	X1f4_E4_CASE,
		NULL,				r_yank_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						6		},
	bo_slmy00,							},
#define r_yank_reach			(r_wcall_reach + (r_yank_count << 1))
#define index_count			0
    {	{	"index",
		_libx1f4i0_lxdash_e_centric,	0,
		NULL,				index_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_SIDE_LIST
		| X1f4_E4_TEXT_LINK,
						5		},
	borneo_l_,							}
#define index_reach			(r_yank_reach + index_count)
/* *INDENT-ON* */
#define auto_line_count			index_reach
}, blue_line[] = {
/* *INDENT-OFF* */
#define rs_greater_count		4
    {	{	fis_greaterf,
		_libx1f4i0_lxdash_0_centric,	X1f4_E4_MODE,
		NULL,				rs_greater_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						10		},
	_slmmx00x,							},
#define rs_greater_reach	(0 + (rs_greater_count << 1))
#define rsd_greater_count			3
    {	{	"isd_greater",
		_libx1f4i0_lxdash_1_centric,	X1f4_E4_MODE,
		NULL,				rsd_greater_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						11		},
	bo_slmx00,							},
#define rsd_greater_reach \
    (rs_greater_reach + (rsd_greater_count << 1))
#define rs_upper_count			4
    {	{	fis_upperf,
		_libx1f4i0_lxdash_0_centric,	X1f4_E4_MODE,
		NULL,				rs_upper_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						8		},
	_slmmx00x,							},
#define rs_upper_reach \
    (rsd_greater_reach + (rs_upper_count << 1))
#define rsd_upper_count			3
    {	{	"isd_upper",
		_libx1f4i0_lxdash_1_centric,	X1f4_E4_MODE,
		NULL,				rsd_upper_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						9		},
	bo_slmx00,							},
#define rsd_upper_reach \
    (rs_upper_reach + (rsd_upper_count << 1))
#define rs_lower_count			4
    {	{	fis_lowerf,
		_libx1f4i0_lxdash_0_centric,	X1f4_E4_MODE,
		NULL,				rs_lower_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						8		},
	_slmmx00x,							},
#define rs_lower_reach \
    (rsd_upper_reach + (rs_lower_count << 1))
#define rsd_lower_count			3
    {	{	"isd_lower",
		_libx1f4i0_lxdash_1_centric,	X1f4_E4_MODE,
		NULL,				rsd_lower_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						9		},
	bo_slmx00,							},
#define rsd_lower_reach \
    (rs_lower_reach + (rsd_lower_count << 1))
#define rs_less_count			4
    {	{	fis_lessf,
		_libx1f4i0_lxdash_0_centric,	X1f4_E4_MODE,
		NULL,				rs_less_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						7		},
	_slmmx00x,							},
#define rs_less_reach \
    (rsd_lower_reach + (rs_less_count << 1))
#define rsd_less_count			3
    {	{	"isd_less",
		_libx1f4i0_lxdash_1_centric,	X1f4_E4_MODE,
		NULL,				rsd_less_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						8		},
	bo_slmx00,							}
#define rsd_less_reach \
    (rs_less_reach + (rsd_less_count << 1))
/* *INDENT-ON* */
#define blue_line_count			rsd_less_reach
}, ever_line[] = {
/* *INDENT-OFF* */
#define r_set_count			2
    {	{	fi_setf,
		_libx1f4i0_lxdash_s_forward,	0,
		NULL,				r_set_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		5		},
	line_sset,							}
#define r_set_reach			(0 + (r_set_count << 1))
/* *INDENT-ON* */
#define ever_line_count			r_set_reach
}, fail_line[] = {
/* *INDENT-OFF* */
#define r_add_count			3
    {	{	fi_addf,
		_libx1f4i0_lxdash_a_forward,	X1f4_E4_VOID,
		NULL,				r_add_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_SLIP_LIST
		| X1f4_E4_TEXT_LINK,		5		},
	borne_lms,							},
#define r_add_reach			(0 + r_add_count)
#define r_bind_count			3
    {	{	fi_bindf,
		_libx1f4i0_lxdash_b_derived,	X1f4_E4_VOID,
		NULL,				r_bind_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_SLIP_LIST
		| X1f4_E4_TEXT_LINK,		6		},
	borne_lms,							},
#define r_bind_reach			(r_add_reach + r_bind_count)
#define r_case_count			3
    {	{	fi_casef,
		_libx1f4i0_lxdash_c_derived,	X1f4_E4_CASE,
		NULL,				r_case_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_SLIP_LIST
		| X1f4_E4_TEXT_LINK,		6		},
	borne_lms,							},
#define r_case_reach			(r_bind_reach + r_case_count)
#define r_dock_count			3
    {	{	fi_dockf,
		_libx1f4i0_lxdash_d_derived,	X1f4_E4_VOID,
		NULL,				r_dock_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_SLIP_LIST
		| X1f4_E4_TEXT_LINK,		6		},
	borne_lms,							},
#define r_dock_reach			(r_case_reach + r_dock_count)
#define r_fix_count			3
    {	{	fi_fixf,
		_libx1f4i0_lxdash_f_derived,	X1f4_E4_VOID,
		NULL,				r_fix_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_SLIP_LIST
		| X1f4_E4_TEXT_LINK,		5		},
	borne_lms,							},
#define r_fix_reach			(r_dock_reach + r_fix_count)
#define r_link_count			3
    {	{	fi_linkf,
		_libx1f4i0_lxdash_l_derived,	X1f4_E4_VOID,
		NULL,				r_link_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_SLIP_LIST
		| X1f4_E4_TEXT_LINK,		6		},
	borne_lms,							},
#define r_link_reach			(r_fix_reach + r_link_count)
#define r_pick_count			2
    {	{	fi_pickf,
		_libx1f4i0_lxdash_p_derived,	X1f4_E4_CASE,
		NULL,				r_pick_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borneo_lm,							},
#define r_pick_reach			(r_link_reach + r_pick_count)
#define r_put_count			3
    {	{	fi_putf,
		_libx1f4i0_lxdash_p_forward,	X1f4_E4_VOID,
		NULL,				r_put_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_SLIP_LIST
		| X1f4_E4_TEXT_LINK,		5		},
	borne_lms,							},
#define r_put_reach			(r_pick_reach + r_put_count)
#define r_query_count			2
    {	{	fi_queryf,
		_libx1f4i0_lxdash_q_forward,	X1f4_E4_CASE,
		NULL,				r_query_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	borneo_lm,							},
#define r_query_reach			(r_put_reach + r_query_count)
#define r_replace_count			3
    {	{	fi_replacef,
		_libx1f4i0_lxdash_r_derived,	X1f4_E4_VOID,
		NULL,				r_replace_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_SLIP_LIST
		| X1f4_E4_TEXT_LINK,		9		},
	borne_lms,							},
#define r_replace_reach			(r_query_reach + r_replace_count)
/* *INDENT-ON* */
#define fail_line_count			r_replace_reach
}, gray_line[] = {
/* *INDENT-OFF* */
#define r_high_count			1
    {	{	"i_high",
		_libx1f4i0_lxdash_g_keeping,	X1f4_E4_MODE,
		NULL,				r_high_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borneo__l,							},
#define r_high_reach			(0 + r_high_count)
#define r_last_count			2
    {	{	"i_last",
		_libx1f4i0_lxdash_h_keeping,	X1f4_E4_MODE,
		NULL,				r_last_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		6		},
	born_lm0x,							},
#define r_last_reach			(r_high_reach + (r_last_count << 1))
#define r_short_count			1
    {	{	"i_short",
		_libx1f4i0_lxdash_a_keeping,	0,
		NULL,				r_short_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	themed__l,							},
#define r_short_reach			(r_last_reach + r_short_count)
#define rb_delete_count			1
    {	{	"ib_delete",
		_libx1f4i0_lxdash_a_keeping,	0,
		NULL,				rb_delete_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						9		},
	themed__l,							},
#define rb_delete_reach			(r_short_reach + rb_delete_count)
/* *INDENT-ON* */
#define gray_line_count			rb_delete_reach
}, head_line[] = {
/* *INDENT-OFF* */
#define r_front_count			1
    {	{	"i_front",
		_libx1f4i0_lxdash_c_keeping,	X1f4_E4_CASE,
		NULL,				r_front_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	borneo__l,							},
#define r_front_reach			(0 + r_front_count)
#define rf_get_count			2
    {	{	"if_get",
		_libx1f4i0_lxdash_j_keeping,	X1f4_E4_CASE,
		NULL,				rf_get_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						6		},
	born_sly0,							},
#define rf_get_reach			(r_front_reach + (rf_get_count << 1))
#define rf_pick_count			1
    {	{	"if_pick",
		_libx1f4i0_lxdash_e_keeping,	X1f4_E4_CASE,
		NULL,				rf_pick_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	borneo__l,							},
#define rf_pick_reach			(rf_get_reach + rf_pick_count)
#define rf_query_count			1
    {	{	"if_query",
		_libx1f4i0_lxdash_c_keeping,	X1f4_E4_CASE,
		NULL,				rf_query_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						8		},
	borneo__l,							},
#define rf_query_reach			(rf_pick_reach + rf_query_count)
#define rf_yank_count			2
    {	{	"if_yank",
		_libx1f4i0_lxdash_i_keeping,	X1f4_E4_CASE,
		NULL,				rf_yank_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						7		},
	born_sly0,							},
#define rf_yank_reach			(rf_query_reach + (rf_yank_count << 1))
#define rs_first_count			3
    {	{	"is_first",
		_libx1f4i0_lxdash_f_keeping,	X1f4_E4_MODE,
		NULL,				rs_first_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						8		},
	bo_slmx0x,							}
#define rs_first_reach			(rf_yank_reach + (rs_first_count << 1))
/* *INDENT-ON* */
#define head_line_count			rs_first_reach
}, post_line[] = {
/* *INDENT-OFF* */
#define b_chance1_count			2
    {	{	fi_chance1f,
		_libx1f4i0_lxdash_q_forward,	X1f4_E4_CASE,
		NULL,				b_chance1_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						9		},
	borneo_lb,							}
#define b_chance1_reach			(0 + b_chance1_count)
/* *INDENT-ON* */
#define post_line_count			b_chance1_reach
}, slip_line[] = {
/* *INDENT-OFF* */
#define r_cast_count			2
    {	{	"i_cast",
		_libx1f4i0_lxdash_c_nearest,	0,
		NULL,				r_cast_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	themed_ll,							},
#define r_cast_reach			(0 + r_cast_count)
#define r_clear_count			1
    {	{	"i_clear",
		_libx1f4i0_lxdash_c_pending,	0,
		NULL,				r_clear_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	themed__l,							},
#define r_clear_reach			(r_cast_reach + r_clear_count)
#define r_copy_count			2
    {	{	"i_copy",
		_libx1f4i0_lxdash_c_logique,	0,
		NULL,				r_copy_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	themed_ll,							},
#define r_copy_reach			(r_clear_reach + r_copy_count)
#define r_delete_count			2
    {	{	"i_delete",
		_libx1f4i0_lxdash_d_logique,	0,
		NULL,				r_delete_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						8		},
	themed_lm,							},
#define r_delete_reach			(r_copy_reach + r_delete_count)
#define r_down_count			2
    {	{	"i_down",
		_libx1f4i0_lxdash_d_forward,	X1f4_E4_VOID,
		NULL,				r_down_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borneo_lm,							},
#define r_down_reach			(r_delete_reach + r_down_count)
#define r_id_count			2
    {	{	"i_id",
		_libx1f4i0_lxdash_i_pending,	X1f4_E4_MODE,
		NULL,				r_id_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						4		},
	borneo_lm,							},
#define r_id_reach			(r_down_reach + r_id_count)
#define r_key_count			2
    {	{	"i_key",
		_libx1f4i0_lxdash_k_logique,	X1f4_E4_MODE,
		NULL,				r_key_count,
		X1f4_E4_KEEP_CALL,
						5		},
	borneo_lm,							},
#define r_key_reach			(r_id_reach + r_key_count)
#define r_move_count			3
    {	{	"i_move",
		_libx1f4i0_lxdash_m_logique,	X1f4_E4_VOID,
		NULL,				r_move_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borne_lmm,							},
#define r_move_reach			(r_key_reach + r_move_count)
#define r_resign_count			2
    {	{	"i_resign",
		_libx1f4i0_lxdash_r_logique,	X1f4_E4_VOID,
		NULL,				r_resign_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						8		},
	themed_lm,							},
#define r_resign_reach			(r_move_reach + r_resign_count)
#define r_size_count			1
    {	{	fi_sizef,
		_libx1f4i0_lxdash_r_forward,	X1f4_E4_MODE,
		NULL,				r_size_count,
		0,				6		},
	borneo__l,							},
#define r_size_reach			(r_resign_reach + r_size_count)
#define r_spin_count			3
    {	{	"i_spin",
		_libx1f4i0_lxdash_s_logique,	X1f4_E4_VOID,
		NULL,				r_spin_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borne_lmm,							},
#define r_spin_reach			(r_size_reach + r_spin_count)
#define r_swap_count			2
    {	{	"i_swap",
		_libx1f4i0_lxdash_s_sequent,	X1f4_E4_VOID,
		NULL,				r_swap_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	themed_ll,							},
#define r_swap_reach			(r_spin_reach + r_swap_count)
#define r_type_count			2
    {	{	"i_type",
		_libx1f4i0_lxdash_t_pending,	X1f4_E4_TEXT,
		NULL,				r_type_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borneo_lm,							},
#define r_type_reach			(r_swap_reach + r_type_count)
#define r_up_count			2
    {	{	"i_up",
		_libx1f4i0_lxdash_u_forward,	X1f4_E4_VOID,
		NULL,				r_up_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						4		},
	borneo_lm,							}
#define r_up_reach			(r_type_reach + r_up_count)
/* *INDENT-ON* */
#define slip_line_count			r_up_reach
}, tail_line[] = {
/* *INDENT-OFF* */
#define r_back_count			1
    {	{	"i_back",
		_libx1f4i0_lxdash_c_keeping,	X1f4_E4_CASE,
		NULL,				r_back_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	borneo__l,							},
#define r_back_reach			(0 + r_back_count)
#define rb_get_count			2
    {	{	"ib_get",
		_libx1f4i0_lxdash_j_keeping,	X1f4_E4_CASE,
		NULL,				rb_get_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						6		},
	born_sly0,							},
#define rb_get_reach			(r_back_reach + (rb_get_count << 1))
#define rb_pick_count			1
    {	{	"ib_pick",
		_libx1f4i0_lxdash_e_keeping,	X1f4_E4_CASE,
		NULL,				rb_pick_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	borneo__l,							},
#define rb_pick_reach			(rb_get_reach + rb_pick_count)
#define rb_query_count			1
    {	{	"ib_query",
		_libx1f4i0_lxdash_c_keeping,	X1f4_E4_CASE,
		NULL,				rb_query_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						8		},
	borneo__l,							},
#define rb_query_reach			(rb_pick_reach + rb_query_count)
#define rb_yank_count			2
    {	{	"ib_yank",
		_libx1f4i0_lxdash_i_keeping,	X1f4_E4_CASE,
		NULL,				rb_yank_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						7		},
	born_sly0,							},
#define rb_yank_reach			(rb_query_reach + (rb_yank_count << 1))
#define rs_last_count			3
    {	{	"is_last",
		_libx1f4i0_lxdash_f_keeping,	X1f4_E4_MODE,
		NULL,				rs_last_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK,
						7		},
	bo_slmx0x,							}
#define rs_last_reach			(rb_yank_reach + (rs_last_count << 1))
/* *INDENT-ON* */
#define tail_line_count			rs_last_reach
}, used_line[] = {
/* *INDENT-OFF* */
#define r_class_count			1
    {	{	"i_class",
		_libx1f4i0_lxdash_a_keeping,	0,
		NULL,				r_class_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	themed__l,							},
#define r_class_reach			(0 + r_class_count)
#define r_first_count			2
    {	{	"i_first",
		_libx1f4i0_lxdash_h_keeping,	X1f4_E4_MODE,
		NULL,				r_first_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		7		},
	born_lm0x,							},
#define r_first_reach			(r_class_reach + (r_first_count << 1))
#define r_low_count			1
    {	{	"i_low",
		_libx1f4i0_lxdash_g_keeping,	X1f4_E4_MODE,
		NULL,				r_low_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						5		},
	borneo__l,							},
#define r_low_reach			(r_first_reach + r_low_count)
#define rf_delete_count			1
    {	{	"if_delete",
		_libx1f4i0_lxdash_a_keeping,	0,
		NULL,				rf_delete_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						9		},
	themed__l,							},
#define rf_delete_reach			(r_low_reach + rf_delete_count)
/* *INDENT-ON* */
#define used_line_count			rf_delete_reach
}, wrap_line[] = {
/* *INDENT-OFF* */
#define rsk_greater_count		3
    {	{	"isk_greater",
		_libx1f4i0_lxdash_0k_queued,	X1f4_E4_MODE,
		NULL,				rsk_greater_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		11		},
	bo_lmm00x,							},
#define rsk_greater_reach		(0 + (rsk_greater_count << 1))
#define rsk_upper_count			3
    {	{	"isk_upper",
		_libx1f4i0_lxdash_0k_queued,	X1f4_E4_MODE,
		NULL,				rsk_upper_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		9		},
	bo_lmm00x,							},
#define rsk_upper_reach \
    (rsk_greater_reach + (rsk_upper_count << 1))
#define rsk_lower_count		3
    {	{	"isk_lower",
		_libx1f4i0_lxdash_0k_queued,	X1f4_E4_MODE,
		NULL,				rsk_lower_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		9		},
	bo_lmm00x,							},
#define rsk_lower_reach \
    (rsk_upper_reach + (rsk_lower_count << 1))
#define rsk_less_count			3
    {	{	"isk_less",
		_libx1f4i0_lxdash_0k_queued,	X1f4_E4_MODE,
		NULL,				rsk_less_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		8		},
	bo_lmm00x,							}
#define rsk_less_reach \
    (rsk_lower_reach + (rsk_less_count << 1))
/* *INDENT-ON* */
#define wrap_line_count		rsk_less_reach
};
static const struct link_type cast_line[] = {
/* *INDENT-OFF* */
#define r_q__class			4
#define r_q__count			2
    {	{	"i_q_",
		NULL,				0,
		NULL,				r_q__count,
		X1f4_E4_TEXT_LINK,		r_q__class	},
	line_qmix,							},
#define r_q__reach			(0 + r_q__count)
#define r_q__trans			(0 + r_q__class)
#define r_qc__class			5
#define r_qc__count			2
    {	{	"i_qc_",
		NULL,				0,
		NULL,				r_qc__count,
		X1f4_E4_TEXT_LINK,		r_qc__class	},
	line_qvix,							},
#define r_qc__reach			(r_q__reach + r_qc__count)
#define r_qc__trans			(r_q__trans + r_qc__class)
#define rb_q__class			5
#define rb_q__count			1
    {	{	"ib_q_",
		NULL,				0,
		NULL,				rb_q__count,
		X1f4_E4_TEXT_LINK,		rb_q__class	},
	line_qpix,							},
#define rb_q__reach			(r_qc__reach + rb_q__count)
#define rb_q__trans			(r_qc__trans + rb_q__class)
#define rf_q__class			5
#define rf_q__count			1
    {	{	"if_q_",
		NULL,				0,
		NULL,				rf_q__count,
		X1f4_E4_TEXT_LINK,		rf_q__class	},
	line_qsix,							}
#define rf_q__reach			(rb_q__reach + rf_q__count)
#define rf_q__trans			(rb_q__trans + rf_q__class)
/* *INDENT-ON* */
#define cast_line_class			rf_q__trans
#define cast_line_count			rf_q__reach
#define cast_line_shift \
    sizeof(cast_line) / sizeof(struct link_type)
}, copy_line[] = {
/* *INDENT-OFF* */
#define r_a__class			4
#define r_a__count			3
    {	{	"i_a_",
		NULL,				X1f4_E4_VOID,
		NULL,				r_a__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						r_a__class	},
	line_amix,							},
#define r_a__reach			(0 + r_a__count)
#define r_a__trans			(0 + r_a__class)
#define r_f__class			4
#define r_f__count			3
    {	{	"i_f_",
		NULL,				0,
		NULL,				r_f__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						r_f__class	},
	line_fmix,							},
#define r_f__reach			(r_a__reach + r_f__count)
#define r_f__trans			(r_a__trans + r_f__class)
#define r_p__class			4
#define r_p__count			3
    {	{	"i_p_",
		NULL,				0,
		NULL,				r_p__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						r_p__class	},
	line_pmix,							},
#define r_p__reach			(r_f__reach + r_p__count)
#define r_p__trans			(r_f__trans + r_p__class)
#define r_r__class			4
#define r_r__count			3
    {	{	"i_r_",
		NULL,				0,
		NULL,				r_r__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						r_r__class	},
	line_rmix,							}
#define r_r__reach			(r_p__reach + r_r__count)
#define r_r__trans			(r_p__trans + r_r__class)
/* *INDENT-ON* */
#define copy_line_class			r_r__trans
#define copy_line_count			r_r__reach
#define copy_line_shift \
    sizeof(copy_line) / sizeof(struct link_type)
}, fast_line[] = {
/* *INDENT-OFF* */
#define r_e__class			4
#define r_e__count			3
    {	{	"i_e_",
		NULL,				X1f4_E4_VOID,
		NULL,				r_e__count,
		0,				r_e__class	},
	line_emix,							},
#define r_e__reach			(0 + r_e__count)
#define r_e__trans			(0 + r_e__class)
#define r_ec__class			5
#define r_ec__count			3
    {	{	"i_ec_",
		NULL,				0,
		NULL,				r_ec__count,
		X1f4_E4_TEXT_LINK,		r_ec__class	},
	line_evix,							},
#define r_ec__reach			(r_e__reach + r_ec__count)
#define r_ec__trans			(r_e__trans + r_ec__class)
#define r_g__class			4
#define r_g__count			3
    {	{	"i_g_",
		NULL,				0,
		NULL,				r_g__count,
		0,				r_g__class	},
	line_gmix,							},
#define r_g__reach			(r_ec__reach + r_g__count)
#define r_g__trans			(r_ec__trans + r_g__class)
#define r_gc__class			5
#define r_gc__count			3
    {	{	"i_gc_",
		NULL,				0,
		NULL,				r_gc__count,
		X1f4_E4_TEXT_LINK,		r_gc__class	},
	line_gvix,							},
#define r_gc__reach			(r_g__reach + r_gc__count)
#define r_gc__trans			(r_g__trans + r_gc__class)
#define r_j__class			4
#define r_j__count			3
    {	{	"i_j_",
		NULL,				X1f4_E4_MODE,
		NULL,				r_j__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		4		},
	line_jmix,							},
#define r_j__reach			(r_gc__reach + r_j__count)
#define r_j__trans			(r_gc__trans + r_j__class)
#define r_o__class			4
#define r_o__count			3
    {	{	"i_o_",
		NULL,				0,
		NULL,				r_o__count,
		0,				r_o__class	},
	line_omix,							},
#define r_o__reach			(r_j__reach + r_o__count)
#define r_o__trans			(r_j__trans + r_o__class)
#define r_s__class			4
#define r_s__count			2
    {	{	"i_s_",
		_libx1f4i0_lxdash_s_pending,	X1f4_E4_MODE,
		NULL,				r_s__count,
		X1f4_E4_TEXT_LINK,		r_s__class	},
	line_smap,							},
#define r_s__reach			(r_o__reach + r_s__count)
#define r_s__trans			(r_o__trans + r_s__class)
#define rb_e__class			5
#define rb_e__count			2
    {	{	"ib_e_",
		NULL,				X1f4_E4_VOID,
		NULL,				rb_e__count,
		0,				rb_e__class	},
	line_epix,							},
#define rb_e__reach			(r_s__reach + rb_e__count)
#define rb_e__trans			(r_s__trans + rb_e__class)
#define rb_g__class			5
#define rb_g__count			2
    {	{	"ib_g_",
		NULL,				0,
		NULL,				rb_g__count,
		0,				rb_g__class	},
	line_gpix,							},
#define rb_g__reach			(rb_e__reach + rb_g__count)
#define rb_g__trans			(rb_e__trans + rb_g__class)
#define rf_e__class			5
#define rf_e__count			2
    {	{	"if_e_",
		NULL,				X1f4_E4_VOID,
		NULL,				rf_e__count,
		0,				rf_e__class	},
	line_esix,							},
#define rf_e__reach			(rb_g__reach + rf_e__count)
#define rf_e__trans			(rb_g__trans + rf_e__class)
#define rf_g__class			5
#define rf_g__count			2
    {	{	"if_g_",
		NULL,				0,
		NULL,				rf_g__count,
		0,				rf_g__class	},
	line_gsix,							},
#define rf_g__reach			(rf_e__reach + rf_g__count)
#define rf_g__trans			(rf_e__trans + rf_g__class)
#define rs_g__class			5
#define rs_g__count			4
    {	{	"is_g_",
		NULL,				X1f4_E4_MODE,
		NULL,				rs_g__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		rs_g__class	},
	lock_gmix,							},
#define rs_g__reach			(rf_g__reach + (rs_g__count << 1))
#define rs_g__trans			(rf_g__trans + rs_g__class)
#define rs_l__class			5
#define rs_l__count			4
    {	{	"is_l_",
		NULL,				X1f4_E4_MODE,
		NULL,				rs_l__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		rs_l__class	},
	lock_lmix,							},
#define rs_l__reach			(rs_g__reach + (rs_l__count << 1))
#define rs_l__trans			(rs_g__trans + rs_l__class)
#define rs_o__class			5
#define rs_o__count			4
    {	{	"is_o_",
		NULL,				X1f4_E4_MODE,
		NULL,				rs_o__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		rs_o__class	},
	lock_omix,							},
#define rs_o__reach			(rs_l__reach + (rs_o__count << 1))
#define rs_o__trans			(rs_l__trans + rs_o__class)
#define rs_u__class			5
#define rs_u__count			4
    {	{	"is_u_",
		NULL,				X1f4_E4_MODE,
		NULL,				rs_u__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		rs_u__class	},
	lock_umix,							}
#define rs_u__reach			(rs_o__reach + (rs_u__count << 1))
#define rs_u__trans			(rs_o__trans + rs_u__class)
/* *INDENT-ON* */
#define fast_line_class			rs_u__trans
#define fast_line_count			rs_u__reach
#define fast_line_shift \
    sizeof(fast_line) / sizeof(struct link_type)
}, long_line[] = {
/* *INDENT-OFF* */
#define r_b__count			3
    {	{	"i_b_",
		_libx1f4i0_lxdash_b_sequent,	0,
		NULL,				r_b__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						4		},
	line_bfar,							},
#define r_b__reach			(0 + r_b__count)
#define r_c__count			3
    {	{	"i_c_",
		_libx1f4i0_lxdash_c_sequent,	0,
		NULL,				r_c__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						4		},
	line_cfar,							},
#define r_c__reach			(r_b__reach + r_c__count)
#define r_d__count			3
    {	{	"i_d_",
		_libx1f4i0_lxdash_d_sequent,	X1f4_E4_VOID,
		NULL,				r_d__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						4		},
	line_dfar,							},
#define r_d__reach			(r_c__reach + r_d__count)
#define r_l__count			3
    {	{	"i_l_",
		_libx1f4i0_lxdash_l_sequent,	0,
		NULL,				r_l__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						4		},
	line_lfar,							}
#define r_l__reach			(r_d__reach + r_l__count)
/* *INDENT-ON* */
#define long_line_class			(long_line_shift * 4)
#define long_line_count			r_l__reach
#define long_line_shift \
    sizeof(long_line) / sizeof(struct link_type)
}, past_line[] = {
/* *INDENT-OFF* */
#define r_x__class			4
#define r_x__count			2
    {	{	"i_x_",
		NULL,				0,
		NULL,				r_x__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						r_x__class	},
	line_xmix,							},
#define r_x__reach			(0 + r_x__count)
#define r_x__trans			(0 + r_x__class)
#define r_xc__class			5
#define r_xc__count			2
    {	{	"i_xc_",
		NULL,				0,
		NULL,				r_xc__count,
		X1f4_E4_TEXT_LINK,		r_xc__class	},
	line_xvix,							},
#define r_xc__reach			(r_x__reach + r_xc__count)
#define r_xc__trans			(r_x__trans + r_xc__class)
#define rb_x__class			5
#define rb_x__count			1
    {	{	"ib_x_",
		NULL,				X1f4_E4_VOID,
		NULL,				rb_x__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						rb_x__class	},
	line_xpix,							},
#define rb_x__reach			(r_xc__reach + rb_x__count)
#define rb_x__trans			(r_xc__trans + rb_x__class)
#define rf_x__class			5
#define rf_x__count			1
    {	{	"if_x_",
		NULL,				X1f4_E4_VOID,
		NULL,				rf_x__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						rf_x__class	},
	line_xsix,							}
#define rf_x__reach			(rb_x__reach + rf_x__count)
#define rf_x__trans			(rb_x__trans + rf_x__class)
/* *INDENT-ON* */
#define past_line_class			rf_x__trans
#define past_line_count			rf_x__reach
#define past_line_shift \
    sizeof(past_line) / sizeof(struct link_type)
}, seek_line[] = {
/* *INDENT-OFF* */
#define r_k__count			3
    {	{	"i_k_",
		_libx1f4i0_lxdash_k_derived,	X1f4_E4_MODE,
		NULL,				r_k__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,		4		},
	line_kway,							}
#define r_k__reach			(0 + (r_k__count << 1))
/* *INDENT-ON* */
#define seek_line_class			(seek_line_shift * 4)
#define seek_line_count			r_k__reach
#define seek_line_shift \
    sizeof(seek_line) / sizeof(struct link_type)
}, skew_line[] = {
/* *INDENT-OFF* */
#define rn_a__count			3
    {	{	"in_a_",
		NULL,				0,
		NULL,				rn_a__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						5		},
	last_amix,							}
#define rn_a__reach			(0 + rn_a__count)
/* *INDENT-ON* */
#define skew_line_class			(skew_line_shift * 5)
#define skew_line_count			rn_a__reach
#define skew_line_shift \
    sizeof(skew_line) / sizeof(struct link_type)
}, spin_line[] = {
/* *INDENT-OFF* */
#define r_n__count			2
    {	{	"i_n_",
		_libx1f4i0_lxdash_n_logique,	0,
		NULL,				r_n__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						4		},
	born_n_lm,							},
#define r_n__reach			(0 + r_n__count)
#define r_v__count			2
    {	{	"i_v_",
		_libx1f4i0_lxdash_v_logique,	0,
		NULL,				r_v__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						4		},
	born_n_lm,							}
#define r_v__reach			(r_n__reach + r_v__count)
/* *INDENT-ON* */
#define spin_line_class			(spin_line_shift * 4)
#define spin_line_count			r_v__reach
#define spin_line_shift \
    sizeof(spin_line) / sizeof(struct link_type)
}, tune_line[] = {
/* *INDENT-OFF* */
#define rn_s__count			3
    {	{	"in_s_",
		NULL,				0,
		NULL,				rn_s__count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						5		},
	last_smix,							}
#define rn_s__reach			(0 + rn_s__count)
/* *INDENT-ON* */
#define tune_line_class			(tune_line_shift * 5)
#define tune_line_count			rn_s__reach
#define tune_line_shift \
    sizeof(tune_line) / sizeof(struct link_type)
};
static const struct patent_type linked[] = {
/* *INDENT-OFF* */
    {	fi_getf,		5,				},
    {	fi_queryf, 		7,				},
    {	fi_pickf,		6,				},
    {	fi_yankf,		6,				}
/* *INDENT-ON* */
}, phased[] = {
/* *INDENT-OFF* */
    {	fis_greaterf,		10,				},
    {	fis_lessf,		7,				},
    {	fis_lowerf,		8,				},
    {	fis_upperf,		8,				}
/* *INDENT-ON* */
}, yanked[] = {
/* *INDENT-OFF* */
    {	fi_addf,		5,				},
    {	fi_bindf,		6,				},
    {	fi_casef,		6,				},
    {	fi_dockf,		6,				},
    {	fi_fixf,		5,				},
    {	fi_linkf,		6,				},
    {	fi_putf,		5,				},
    {	fi_replacef,		9,				}
/* *INDENT-ON* */
};
static const struct x1f4_postmark_type side_k[] = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("]", " "),	1				}
/* *INDENT-ON* */
};
static const struct x1f4_operator_type rail_f[] = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("=", " "),  NULL,		0400,
	0,			NULL,
	X1f4_E4_BACK_LINK | X1f4_E4_E2ND_LINK,
				1,
	NULL,			NULL					}
/* *INDENT-ON* */
}, rail_m[] = {
/* *INDENT-OFF* */
    {	MAKE_DOUBLE("-", "="),  NULL,		0400,
	0,			NULL,
	X1f4_E4_BACK_LINK | X1f4_E4_E2ND_LINK,
				2,
	NULL,			NULL					}
/* *INDENT-ON* */
}, rail_p[] = {
/* *INDENT-OFF* */
    {	MAKE_DOUBLE("+", "="),  NULL,		0400,
	0,			NULL,
	X1f4_E4_BACK_LINK | X1f4_E4_E2ND_LINK,
				2,
	NULL,			NULL					}
/* *INDENT-ON* */
}, side_o[] = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("=", " "),  NULL,		0400,
	0,			NULL,
	X1f4_E4_BACK_LINK | X1f4_E4_E2ND_LINK | X1f4_E4_LEFT_XSET,
				1,
	NULL,			NULL					},
    {	MAKE_SINGLE("[", " "),  NULL,		0200,
	0,			NULL,
	X1f4_E4_E2ND_LINK,	1,
	NULL,			NULL					},
    {	MAKE_SINGLE("[", " "),  NULL,		0200,
	0,			NULL,
	X1f4_E4_E2ND_LINK,	1,
	NULL,			NULL					}
/* *INDENT-ON* */
}, side_u[] = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("~", " "),  NULL,		0210,
	0,			NULL,
	X1f4_E4_E2ND_LINK,
				1,
	NULL,			NULL					}
/* *INDENT-ON* */
};

static int
init_line(struct lxdash_type *lxdash_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    int status;

    if (bits & AUTOLINK_LINK) {
	lxdash_data->link_v = screen_data->lock_v;
    } else {
	lxdash_data->link_v.data = NULL;
	lxdash_data->link_v.free = NULL;
	lxdash_data->link_v.link = NULL;
	lxdash_data->link_v.mode = NULL;
	lxdash_data->link_v.pick = NULL;
	lxdash_data->link_v.slip = NULL;
    }

    if (bits & CODELINK_LINK) {
	lxdash_data->link_w = screen_data->lock_w;
    } else {
	lxdash_data->link_w.data = NULL;
	lxdash_data->link_w.free = _x1f4_e4_free_data;
	lxdash_data->link_w.link = _x1f4_e4_link_data;
	lxdash_data->link_w.mode = _x1f4_e4_mode_data;
    }

    if (bits & EELOOKUP_LINK) {
	lxdash_data->trap_e.eelookup_data = screen_data->lock_g.eelookup_data;
    } else {
	lxdash_data->trap_e.eelookup_data = &_x1f4_type_lookup;
    }

    if (bits & MISSBAIL_LINK) {
	lxdash_data->link_r.call = screen_data->lock_r.call;
	lxdash_data->link_r.fine = screen_data->lock_r.fine;
	lxdash_data->link_r.miss = screen_data->lock_r.miss;
	lxdash_data->link_r.text = screen_data->lock_r.text;
    } else {
	lxdash_data->link_r.call = NULL;
	lxdash_data->link_r.fine = NULL;
	lxdash_data->link_r.miss = NULL;
    }

    if (bits & COMPOSER_LINK) {
	lxdash_data->link_q = screen_data->lock_q;
    } else {
	lxdash_data->link_q.link = NULL;
    }

    if (bits & IMPLICIT_LINK) {
	lxdash_data->link_p.link = screen_data->lock_p.link;
	lxdash_data->link_p.text = screen_data->lock_p.text;
    } else {
	lxdash_data->link_p.link = NULL;
	lxdash_data->link_p.text = NULL;
    }

    if (bits & RESOURCE_LINK) {
	lxdash_data->link_m = screen_data->lock_m;
    } else {
	lxdash_data->link_m.data = NULL;
	lxdash_data->link_m.free = _x1f4_e4_free_data;
	lxdash_data->link_m.link = _x1f4_e4_link_data;
	lxdash_data->link_m.mode = _x1f4_e4_mode_data;
    }

    if (bits & TEXTFLAT_LINK) {
	lxdash_data->link_e = screen_data->lock_e;
    } else {
	lxdash_data->link_e.data = NULL;
	lxdash_data->link_e.line = NULL;
	lxdash_data->link_e.post = NULL;
	lxdash_data->link_e.push = NULL;
    }

    if (bits & TRANSFER_LINK) {
	lxdash_data->link_o.fine = screen_data->link_o.fine;
    } else {
	lxdash_data->link_o.fine = NULL;
    }

    status = link_line(lxdash_data, bits, screen_data);

    return status;
}


static int
line_data(struct lxdash_type *lxdash_data, unsigned bits,
	  const struct depart_type *part_data, void *data, void *text,
	  void **args, void **dana)
{
#define cxbend_ever			lxdash_data->rule_f.cxbend + 1
#define cxbend_lead			lxdash_data->rule_f.cxbend + 0

    struct lxtext_type *lxtext_data;
    const struct lxtype_type *lxtype_data;
    const struct screen_type *screen_data;
    struct x1f4_linetext_type *linetext_data;
    unsigned i;

    screen_data = part_data->screen_data;

    lxtype_data = screen_data->lock_t.data;

    linetext_data = data;
    lxtext_data = text;

    lxtype_data--;

    _x1f4_type_effect(&lxtext_data->lxtype, X1f4_E4_CALL);
    lxtext_data->text = lxdash_data;

    i = screen_data->lock_t.miss;
    for (; i; i--) {
	int code;
	unsigned flags;

	lxtext_data++;

	lxtype_data++;

	line_sail
	    (lxdash_data, screen_data, lxtext_data, lxtype_data, args, dana);

	flags = lxtype_data->flags;

	if (flags & X1f4_LX_TYPE_EXCEPT) {
	    continue;
	}

	if (1) {
	    _libx1f4i0_lxcall_push_line
		(lxtext_data, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, fast_line_shift, fast_line);
	}
	if (bits & AUTOLINK_LINK) {
	    _libx1f4i0_lxcall_push_line
		(lxtext_data, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, cast_line_shift, cast_line);
	}

	code = lxtype_data->code;

	if (code == X1f4_E4_BILL || code == X1f4_E4_MODE
	    || code == X1f4_E4_REAL) {
	    _libx1f4i0_lxcall_push_line
		(cxbend_lead, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, skew_line_shift, skew_line);
	    _libx1f4i0_lxcall_push_line
		(cxbend_ever, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, tune_line_shift, tune_line);
	}

	if (bits & AUTOLINK_LINK
	    || (!lxtype_data->lead && true(code != X1f4_E4_TEXT))) {
	    _libx1f4i0_lxcall_push_line
		(lxtext_data, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, past_line_shift, past_line);
	}

	if (flags & LINK_ACCESS) {
	    _libx1f4i0_lxcall_push_line
		(lxtext_data, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, long_line_shift, long_line);
	}
	if (0) {
	} else {
	    _libx1f4i0_lxcall_push_line
		(lxtext_data, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, copy_line_shift, copy_line);
	}
	if (flags & POST_ACCESS && bits & AUTOLINK_LINK) {
	    _libx1f4i0_lxcall_push_line
		(lxtext_data, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, spin_line_shift, spin_line);
	}
	if (flags & POST_ACCESS && X1f4_E4_LAST < code && lxtype_data->lead) {
	    _libx1f4i0_lxcall_push_line
		(lxtext_data, bits, part_data, &linetext_data, lxtype_data,
		 args, dana, seek_line_shift, seek_line);
	}
    }

    return 0;

#undef cxbend_lead
#undef cxbend_ever
}


static int
line_line(struct lxdash_type *lxdash_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    lxdash_data->link_t.datatype[0].context = lxdash_data;

    lxdash_data->link_t.datatype[0].flat = _libx1f4i0_lxdash_flat_line;
    lxdash_data->link_t.datatype[0].lead = _libx1f4i0_lxdash_lead_line;
    lxdash_data->link_t.datatype[0].line = _libx1f4i0_lxdash_line_line;
    lxdash_data->link_t.datatype[0].link = _libx1f4i0_lxdash_link_line;
    lxdash_data->link_t.datatype[0].name = "index";
    lxdash_data->link_t.datatype[0].slip = _libx1f4i0_lxdash_slip_line;
    lxdash_data->link_t.datatype[0].size = 5;
    lxdash_data->link_t.datatype[0].type = screen_data->link_l.type;

    lxdash_data->link_s.nodetype[0].context = lxdash_data;

    _libx1f4i0_lxdash_type_line
	(lxdash_data->link_s.nodetype + 0, screen_data->link_l.type);

    lxdash_data->link_t.datatype[1].context = NULL;

    lxdash_data->link_t.datatype[1].flat = NULL;
    lxdash_data->link_t.datatype[1].lead = NULL;
    lxdash_data->link_t.datatype[1].line = NULL;
    lxdash_data->link_t.datatype[1].link = NULL;
    lxdash_data->link_t.datatype[1].name = NULL;
    lxdash_data->link_t.datatype[1].slip = NULL;
    lxdash_data->link_t.datatype[1].size = 0;
    lxdash_data->link_t.datatype[1].type = 0;

    return 0;
}


static int
line_plus(struct lxdash_type *lxdash_data)
{
    int i;
    struct cxbend_type *cxbend_data;
    struct cxseek_type *cxseek_data;

    cxbend_data = lxdash_data->rule_f.cxbend;

    cxbend_data[0].bend = 0;
    cxbend_data[0].line = lxdash_data;
    cxbend_data[0].pick = _libx1f4i0_lead_lxfset;
    cxbend_data[0].sign = 1;
    cxbend_data[0].slip = _libx1f4i0_mind_lxfset;

    cxbend_data++;

    cxbend_data[0].bend = 1;
    cxbend_data[0].line = lxdash_data;
    cxbend_data[0].pick = _libx1f4i0_ever_lxfset;
    cxbend_data[0].sign = -1;
    cxbend_data[0].slip = _libx1f4i0_slip_lxfset;

    cxseek_data = lxdash_data->rule_f.cxseek;

    cxseek_data[0].seek = _libx1f4i0_fgxd_lxfset;
    cxseek_data[1].seek = _libx1f4i0_fxxd_lxfset;
    cxseek_data[2].seek = _libx1f4i0_lxxd_lxfset;
    cxseek_data[3].seek = _libx1f4i0_llxd_lxfset;

    i = 4;
    for (; i; i--) {
	cxseek_data->line = lxdash_data;
	cxseek_data++;
    }

    return 0;
}


static int
line_rail(void *data, unsigned pass, struct x1f4_operator_type *operator_rail,
	  struct x1f4_2ndscope_type *scope2nd_rail,
	  struct x1f4_linetext_type *linetext_data)
{
    int i = 2;
    struct ticket_type *ticket_data;
    struct x1f4_2ndscope_type *scope2nd_data;
    struct x1f4_operator_type *operator_data; 
    struct x1f4_raillist_type *raillist_data;

    ticket_data = data;

    raillist_data = (void *) scope2nd_rail;
    raillist_data--;
    raillist_data->miss = fi_size(pass);
    raillist_data->operator_data = operator_rail;

    for (; i; i--) {
	ticket_data--;
	operator_data = &ticket_data->operator;
	scope2nd_data = &ticket_data->tidespan;
	scope2nd_data->bits |= X1f4_E4_POST_MARK | X1f4_E4_RAIL_LIST;
	scope2nd_data->post = side_k;
	scope2nd_data->rail = raillist_data;
    }

    while (linetext_data->function.name != fi_casef) {
	linetext_data++;
    }

    operator_data = operator_rail + fi_size(pass) - 1;
    scope2nd_data = scope2nd_rail + fi_size(pass) - 1;

    *operator_data = *rail_f;
    operator_data->args = linetext_data->function.args + 1;
    operator_data->type = X1f4_E4_CASE;
    operator_data->extension2 = scope2nd_data;
    scope2nd_data->bits = 0;
    scope2nd_data->line = linetext_data;

    return 0;
}


static int
line_sail(struct lxdash_type *lxdash_data,
	  const struct screen_type *screen_data,
	  struct lxtext_type *lxtext_data,
	  const struct lxtype_type *lxtype_data, void **subtext, void **dana)
{
    int code;

    code = lxtype_data->code;

    lxtext_data->lxtype = *lxtype_data;
    lxtext_data->text = lxdash_data;

    if (0) {
    } else {
	if (code == X1f4_E4_TEXT) {
	    lxtext_data->lxtype.context = &lxdash_data->ever_a;

	    lxtext_data->lxtype.copy = _libx1f4i0_lxnext_copy_text;
	    lxtext_data->lxtype.free = _libx1f4i0_lxnext_free_text;
	    lxtext_data->lxtype.lead = _libx1f4i0_lxnext_lead_text;
	    lxtext_data->lxtype.move = NULL;
	    lxtext_data->lxtype.push = _libx1f4i0_lxnext_push_text;
	    lxtext_data->lxtype.slip = _libx1f4i0_lxnext_slip_text;
	}
    }

    return 0;
}


static int
line_text(struct lxdash_type *lxdash_data, unsigned bits,
	  const struct depart_type *part_data, void *data, void **args,
	  void **dana)
{
#define cxbend_ever			lxdash_data->rule_f.cxbend + 1
#define cxbend_lead			lxdash_data->rule_f.cxbend + 0

    struct x1f4_linetext_type *linetext_data;

    linetext_data = data;

    if (1) {
	_libx1f4i0_lxcall_side_line
	    (cxbend_ever, bits, part_data, &linetext_data, args,
	     sizeof(gray_line) / sizeof(struct line_type), gray_line);
	_libx1f4i0_lxcall_side_line
	    (lxdash_data, bits, part_data, &linetext_data, args,
	     sizeof(slip_line) / sizeof(struct line_type), slip_line);
	_libx1f4i0_lxcall_side_line
	    (cxbend_lead, bits, part_data, &linetext_data, args,
	     sizeof(used_line) / sizeof(struct line_type), used_line);
    }
    if (1) {
        part_text
            (lxdash_data, bits, part_data, &linetext_data, args,
             sizeof(wrap_line) / sizeof(struct line_type), wrap_line);
    }
    if (bits & AUTOLINK_LINK) {
	_libx1f4i0_lxcall_side_line
	    (lxdash_data, bits, part_data, &linetext_data, args,
	     sizeof(auto_line) / sizeof(struct line_type), auto_line);
        part_text
            (lxdash_data, bits, part_data, &linetext_data, args,
             sizeof(blue_line) / sizeof(struct line_type), blue_line);
	_libx1f4i0_lxcall_side_line
	    (lxdash_data, bits, part_data, &linetext_data, args,
	     sizeof(ever_line) / sizeof(struct line_type), ever_line);
	_libx1f4i0_lxcall_side_line
	    (lxdash_data, bits, part_data, &linetext_data, args,
	     sizeof(fail_line) / sizeof(struct line_type), fail_line);
	_libx1f4i0_lxcall_side_line
	    (cxbend_lead, bits, part_data, &linetext_data, args,
	     sizeof(head_line) / sizeof(struct line_type), head_line);
	_libx1f4i0_lxcall_side_line
	    (cxbend_ever, bits, part_data, &linetext_data, args,
	     sizeof(tail_line) / sizeof(struct line_type), tail_line);
    }
    if (1) {
	_libx1f4i0_lxcall_zero_line(linetext_data);
    }
    if (1) {
	linetext_data++;
    }
    if (1) {
	_libx1f4i0_lxcall_side_line
	    (lxdash_data, bits, part_data, &linetext_data, args,
	     sizeof(post_line) / sizeof(struct line_type), post_line);
    }
    if (1) {
	_libx1f4i0_lxcall_zero_line(linetext_data);
    }

    return 0;

#undef cxbend_lead
#undef cxbend_ever
}


static int
link_line(struct lxdash_type *lxdash_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    int status;
    unsigned args_class, args_count, line_class, line_count, main_class,
	main_count, miss, pass, trap, trip;
    void *data;

    args_count = 0;
    line_count = 2;
    main_count = 0;

    miss = screen_data->lock_t.miss;

    pick_miss(&args_class, &line_class, &main_class, &pass, bits, screen_data);

    trap = bits & RELATION_LINK ? 2 : 0;
    trip = bits & RELATION_LINK ? 1 : 0;

    {
	args_count += gray_line_count;
	line_count += sizeof(gray_line) / sizeof(struct line_type);
	args_count += slip_line_count;
	line_count += sizeof(slip_line) / sizeof(struct line_type);
	args_count += used_line_count;
	line_count += sizeof(used_line) / sizeof(struct line_type);
    }
    if (1) {
	args_count += wrap_line_count;
	line_count += sizeof(wrap_line) / sizeof(struct line_type);
    }
    if (bits & AUTOLINK_LINK) {
	args_count += auto_line_count;
	line_count += sizeof(auto_line) / sizeof(struct line_type);
	args_count += blue_line_count;
	line_count += sizeof(blue_line) / sizeof(struct line_type);
	args_count += ever_line_count;
	line_count += sizeof(ever_line) / sizeof(struct line_type);
	args_count += fail_line_count;
	line_count += sizeof(fail_line) / sizeof(struct line_type);
	args_count += head_line_count;
	line_count += sizeof(head_line) / sizeof(struct line_type);
	args_count += tail_line_count;
	line_count += sizeof(tail_line) / sizeof(struct line_type);
    }
    {
	args_count += post_line_count;
	line_count += sizeof(post_line) / sizeof(struct line_type);
    }

    status = lxdash_data->link_w.link
	(lxdash_data->link_w.data, &data,
	 sizeof(struct lxtext_type) * (1 + miss) + fm_size(away)
	 + (args_class + args_count) * sizeof(int)
	 + (line_class + line_count) * sizeof(struct x1f4_linetext_type)
	 + (sizeof(struct ticket_type) + sizeof(struct x1f4_operator_type *))
	 * (fb_size() + fp_size()) + sizeof(struct x1f4_operator_type *) * 2
	 + ((sizeof(struct x1f4_ftaa_type) + sizeof(struct x1f4_ftca_type))
	    * (pass + 1) + sizeof(struct x1f4_fpdetail_type)) * trap
	 + ((sizeof(struct x1f4_ftsl_type)) * (pass + 1)
	    + sizeof(struct x1f4_fpdetail_type)) * trap
	 + ((sizeof(struct x1f4_ftsl_type)) * (pass + 1)
	    + sizeof(struct x1f4_fpdetail_type)) * trip * (8 + 4)
	 + (sizeof(struct x1f4_operator_type)
	    + sizeof(struct x1f4_2ndscope_type)) * fi_size(pass)
	 + sizeof(struct x1f4_raillist_type) + main_class + main_count);
    if (status) {
	status = LINK_ERROR;
    } else {
	struct depart_type part;
	void *args, *dana, *port, *rail, *rate, *side, *tile, *text;

	tile = (struct x1f4_linetext_type *) data + line_class;
	dana = (struct x1f4_linetext_type *) tile + line_count;

	if (trap) {
	    _libx1f4i0_lxrail_line_past(&part, pass, &dana);
	    _libx1f4i0_lxrail_line_fast(&part, pass, &dana);
	    _libx1f4i0_lxrail_line_cast(&part, pass, &dana);
	} else {
	    memset(&part, 0, sizeof(struct depart_type));
	}

	/*
	 * lxmiss and lxtext records required together
	 */
	text = (struct lxmiss_type *) dana + 1;
	side = (struct lxtext_type *) text + 1 + miss;
	side = (struct ticket_type *) side + fb_size();
	rate = (struct x1f4_operator_type **) side + fb_size() + 1;
	rate = (struct ticket_type *) rate + fp_size();
	port = (struct x1f4_operator_type **) rate + fp_size() + 1;
	port = (struct x1f4_raillist_type *) port + 1;
	rail = (struct x1f4_2ndscope_type *) port + fi_size(pass);
	args = (struct x1f4_operator_type *) rail + fi_size(pass);
	dana = (int *) args + args_class + args_count;

	((struct lxmiss_type *) text - 1)->data.miss = miss;

	part.screen_data = screen_data;

	line_plus(lxdash_data);

	lxdash_data->link_f.data = port;
	lxdash_data->link_f.side = rail;

	line_data(lxdash_data, bits, &part, data, text, &args, &dana);
	line_text(lxdash_data, bits, &part, tile, &args, &dana);
	_libx1f4i0_lxcall_line_side(rate, data, side_u, side_l, fp_size());
	_libx1f4i0_lxcall_line_vice
	    (side, data,
	     (struct x1f4_linetext_type *) data + line_class + line_count - 1
	     - sizeof(post_line) / sizeof(struct line_type), side_o, side_f,
	     fb_size());

	line_rail(side, pass, rail, port, data);

	/*
	 * link_f abused for line_data, etc, not to be set until after.
	 */

	lxdash_data->link_f.data = data;
	lxdash_data->link_f.rate = rate;
	lxdash_data->link_f.side = side;
	lxdash_data->link_f.text = text;

	line_line(lxdash_data, bits, screen_data);

	if (trap) {
	    _libx1f4i0_lxrail_link_past
		(screen_data->link_y.linetrap_data, &part, linked);
	    _libx1f4i0_lxrail_link_fast
		(screen_data->link_y.linetrap_data, &part, phased);
	    _libx1f4i0_lxrail_link_cast
		(screen_data->link_y.linetrap_data, &part, yanked);
	}

	if (status) {
	    lxdash_data->link_w.free(lxdash_data->link_w.data, data);
	} else {
	}
    }

    return status;
}


static int
part_text(struct lxdash_type *lxdash_data, unsigned bits,
	  const struct depart_type *part_data,
	  struct x1f4_linetext_type **linetext, void **args, unsigned count,
	  const struct line_type *line_data)
{
    struct cxseek_type *cxseek_data;
    struct x1f4_linetext_type *linetext_data;
    unsigned i = 4;

    cxseek_data = lxdash_data->rule_f.cxseek;

    linetext_data = *linetext;

    count >>= 2;

    for (; i; i--) {
	_libx1f4i0_lxcall_side_line
	    (cxseek_data, bits, part_data, &linetext_data, args, count,
	     line_data);
	cxseek_data++;
	line_data += count;
    }

    *linetext = linetext_data;

    return 0;
}


static int
pick_miss(unsigned *args, unsigned *line, unsigned *pick, unsigned *pass,
	  unsigned bits, const struct screen_type *screen_data)
{
    const struct lxtype_type *lxtype_data;
    unsigned args_count = 0, line_count = 0, i, main_count = 0, miss;

    lxtype_data = screen_data->lock_t.data;
    lxtype_data--;

    miss = screen_data->lock_t.miss;

    i = miss;
    for (; i; i--) {
	int code;
	unsigned deck, flags;

	lxtype_data++;

	flags = lxtype_data->flags;

	if (flags & X1f4_LX_TYPE_EXCEPT) {
	    miss--;
	    if (1) {
		continue;
	    }
	}

	deck = lxtype_data->size + 1;

	if (1) {
	    args_count += fast_line_count;
	    line_count += fast_line_shift;
	    main_count += deck * fast_line_shift + fast_line_class;
	}
	if (bits & AUTOLINK_LINK) {
	    args_count += cast_line_count;
	    line_count += cast_line_shift;
	    main_count += deck * cast_line_shift + cast_line_class;
	}

	code = lxtype_data->code;

	if (code == X1f4_E4_BILL || code == X1f4_E4_MODE
	    || code == X1f4_E4_REAL) {
	    args_count += skew_line_count;
	    line_count += skew_line_shift;
	    main_count += deck * skew_line_shift + skew_line_class;
	    args_count += tune_line_count;
	    line_count += tune_line_shift;
	    main_count += deck * tune_line_shift + tune_line_class;
	    if (flags & FLAT_REFLEX) {
	    } else {
	    }
	}

	if (bits & AUTOLINK_LINK
	    || (!lxtype_data->lead && true(code != X1f4_E4_TEXT))) {
	    args_count += past_line_count;
	    line_count += past_line_shift;
	    main_count += deck * past_line_shift + past_line_class;
	}

	if (flags & FLAT_REFLEX) {
	} else {
	    args_count += l_e_type_post;
	    args_count += l_ec_set_post;
	    args_count += l_g_type_post;
	    args_count += l_gc_set_post;
	    args_count += l_j_type_post;
	    args_count += l_o_type_post;
	    args_count += lbe_type_post;
	    args_count += lbg_type_post;
	    args_count += lfe_type_post;
	    args_count += lfg_type_post;
	}
	if (flags & LINK_ACCESS) {
	    args_count += long_line_count;
	    line_count += long_line_shift;
	    main_count += deck * long_line_shift + long_line_class;
	}
	if (0) {
	} else {
	    args_count += copy_line_count;
	    line_count += copy_line_shift;
	    main_count += deck * copy_line_shift + copy_line_class;
	}
	if (flags & POST_ACCESS && bits & AUTOLINK_LINK) {
	    args_count += spin_line_count;
	    line_count += spin_line_shift;
	    main_count += deck * spin_line_shift + spin_line_class;
	}
	if (flags & POST_ACCESS && X1f4_E4_LAST < code && lxtype_data->lead) {
	    args_count += seek_line_count;
	    line_count += seek_line_shift;
	    main_count += deck * seek_line_shift + seek_line_class;
	}
    }

    *pass = miss;

    *args = args_count;
    *line = line_count;
    *pick = main_count;

    return 0;
}


static void
_slmmx00x(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_SLIP;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_POST_XSET;
    *line++ = 0;
    *line++ = 0;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;
}


static void
bo_lmm00x(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = 0;
    *line++ = 0;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;
}


static void
bo_slmx00(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_SLIP;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_POST_XSET;
    *line++ = 0;
    *line++ = 0;

    *args = line;
}


static void
bo_slmx0x(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_SLIP;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_POST_XSET;
    *line++ = 0;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;
}


static void
bo_slmy00(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_SLIP;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_POST_FLAT | X1f4_E4_POST_XSET;
    *line++ = 0;
    *line++ = 0;

    *args = line;
}


static void
born_lm0x(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = 0;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;
}


static void
born_n_lm(v_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.type = nodetype_data->code;
}


static void
born_sly0(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_SLIP;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_POST_FLAT | X1f4_E4_POST_XSET;
    *line++ = 0;

    *args = line;
}


static void
borne_lcm(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_CASE;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


static void
borne_lmm(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


static void
borne_lms(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_SLIP;

    *args = line;
}


static void
borneo__l(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;

    *args = line;
}


static void
borneo_l_(u_case_args_____1)
{
    linetext_data->function.type = screen(screen)->link_l.type;
}


static void
borneo_lb(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_BILL;

    *args = line;
}


static void
borneo_lm(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


static void
last_amix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_0mix
        (v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
         rate_0vix);

    rail_plus
	(linetext_data, ((struct cxbend_type *) linetext_data->context)->line,
	 rail_p);
}


static void
last_smix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_0mix
        (v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
         rate_0vix);

    rail_plus
	(linetext_data, ((struct cxbend_type *) linetext_data->context)->line,
	 rail_m);
}


static void
line_amix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_pmix
        (v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
         rate_amix);

    if (nodetype_data->flags & LINK_ACCESS) {
    } else {
	struct x1f4_ftsl_type *ftsl_data;

	ftsl_data = part(screen)->ftsl_dlaw;
	if (ftsl_data) {
	    ftsl_data->linetext_data = linetext_data;
	    ftsl_data->type = nodetype_data->code;
	    part(screen)->ftsl_dlaw = ftsl_data + 1;
	}
    }

    if (0) {
    } else {
	struct x1f4_ftsl_type *ftsl_data;

	ftsl_data = part(screen)->ftsl_alaw;
	if (ftsl_data) {
	    ftsl_data->linetext_data = linetext_data;
	    ftsl_data->type = nodetype_data->code;
	    part(screen)->ftsl_alaw = ftsl_data + 1;
	}
    }
}


static void
line_bfar(v_case_args_____1)
{
    int *line, type;
    struct x1f4_ftsl_type *ftsl_data;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = type;

    *args = line;

    linetext_data->function.type = type;

    ftsl_data = part(screen)->ftsl_blaw;
    if (ftsl_data) {
	ftsl_data->linetext_data = linetext_data;
	ftsl_data->type = type;
	part(screen)->ftsl_blaw = ftsl_data + 1;
    }
}


static void
line_cfar(v_case_args_____1)
{
    int *line, type;
    struct x1f4_ftsl_type *ftsl_data;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = nodetype_data->code;

    *args = line;

    linetext_data->function.type = type;

    rail_plus
	(linetext_data, ((struct lxtext_type *) linetext_data->context)->text,
	 rail_f);

    ftsl_data = part(screen)->ftsl_claw;
    if (ftsl_data) {
	ftsl_data->linetext_data = linetext_data;
	ftsl_data->type = type;
	part(screen)->ftsl_claw = ftsl_data + 1;
    }
}


static void
line_dfar(v_case_args_____1)
{
    int *line, type;
    struct x1f4_ftsl_type *ftsl_data;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = type;

    *args = line;

    ftsl_data = part(screen)->ftsl_dlaw;
    if (ftsl_data) {
	ftsl_data->linetext_data = linetext_data;
	ftsl_data->type = type;
	part(screen)->ftsl_dlaw = ftsl_data + 1;
    }
}


static void
line_emix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_emix
        (v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE, ~0,
         &part(screen)->ftsl_ylaw, rate_emix);
}


static void
line_epix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_esix
	(v_case_args_____2, screen(screen)->link_l.type,
	 ((struct lxdash_type *)
	  ((struct lxtext_type *)
	   linetext_data->context)->text)->rule_f.cxbend + 1, rate_epix);
}


static void
line_esix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_esix
	(v_case_args_____2, screen(screen)->link_l.type,
	 ((struct lxdash_type *)
	  ((struct lxtext_type *)
	   linetext_data->context)->text)->rule_f.cxbend + 0, rate_esix);
}


static void
line_evix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_imix
        (v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
         &part(screen)->ftaa_xlaw, rate_evix);
}


static void
line_fmix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_fmix
        (v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
         rate_fmix);

    if (nodetype_data->flags & LINK_ACCESS) {
    } else {
	struct x1f4_ftsl_type *ftsl_data;

	rail_plus
	    (linetext_data,
	     ((struct lxtext_type *) linetext_data->context)->text, rail_f);

	ftsl_data = part(screen)->ftsl_claw;
	if (ftsl_data) {
	    ftsl_data->linetext_data = linetext_data;
	    ftsl_data->type = nodetype_data->code;
	    part(screen)->ftsl_claw = ftsl_data + 1;
	}
    }

    if (0) {
    } else {
	struct x1f4_ftsl_type *ftsl_data;

	ftsl_data = part(screen)->ftsl_flaw;
	if (ftsl_data) {
	    ftsl_data->linetext_data = linetext_data;
	    ftsl_data->type = nodetype_data->code;
	    part(screen)->ftsl_flaw = ftsl_data + 1;
	}
    }
}


static void
line_gmix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_gmix
        (v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
	 &part(screen)->ftsl_glaw, rate_gmix);
}


static void
line_gpix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_gsix
	(v_case_args_____2, screen(screen)->link_l.type,
	 ((struct lxdash_type *)
	  ((struct lxtext_type *)
	   linetext_data->context)->text)->rule_f.cxbend + 1, rate_gpix);
}


static void
line_gsix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_gsix
	(v_case_args_____2, screen(screen)->link_l.type,
	 ((struct lxdash_type *)
	  ((struct lxtext_type *)
	   linetext_data->context)->text)->rule_f.cxbend + 0, rate_gsix);
}


static void
line_gvix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_imix
        (v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
         &part(screen)->ftaa_qlaw, rate_gvix);
}


static void
line_jmix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_jmix
	(v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
	 X1f4_E4_MODE, rate_jmix);
}


static void
line_kway(v_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = nodetype_data->code;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_POST_XSET;
    *line++ = 0;
    *line++ = 0;

    *args = line;
}


static void
line_lfar(v_case_args_____1)
{
    int *line, type;
    struct x1f4_ftsl_type *ftsl_data;

    line = *args;

    linetext_data->function.args = line;

    type = nodetype_data->code;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = type;

    *args = line;

    linetext_data->function.type = type;

    ftsl_data = part(screen)->ftsl_llaw;
    if (ftsl_data) {
	ftsl_data->linetext_data = linetext_data;
	ftsl_data->type = type;
	part(screen)->ftsl_llaw = ftsl_data + 1;
    }
}


static void
line_nset(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;
}


static void
line_omix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_omix
        (v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
         X1f4_E4_MODE, rate_omix);
}


static void
line_pmix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_fmix
        (v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
         rate_pmix);

    if (nodetype_data->flags & LINK_ACCESS) {
    } else {
	struct x1f4_ftsl_type *ftsl_data;

	ftsl_data = part(screen)->ftsl_llaw;
	if (ftsl_data) {
	    ftsl_data->linetext_data = linetext_data;
	    ftsl_data->type = nodetype_data->code;
	    part(screen)->ftsl_llaw = ftsl_data + 1;
	}
    }

    if (0) {
    } else {
	struct x1f4_ftsl_type *ftsl_data;

	ftsl_data = part(screen)->ftsl_plaw;
	if (ftsl_data) {
	    ftsl_data->linetext_data = linetext_data;
	    ftsl_data->type = nodetype_data->code;
	    part(screen)->ftsl_plaw = ftsl_data + 1;
	}
    }
}


static void
line_qmix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_wmix
	(v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
	 rate_qmix);
}


static void
line_qpix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_qsix
	(v_case_args_____2, screen(screen)->link_l.type,
	 ((struct lxdash_type *)
	  ((struct lxtext_type *)
	   linetext_data->context)->text)->rule_f.cxbend + 1, rate_qpix);
}


static void
line_qsix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_qsix
	(v_case_args_____2, screen(screen)->link_l.type,
	 ((struct lxdash_type *)
	  ((struct lxtext_type *)
	   linetext_data->context)->text)->rule_f.cxbend + 0, rate_qsix);
}


static void
line_qvix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_qmix
	(v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
	 &part(screen)->ftca_qlaw, rate_qvix);
}


static void
line_rmix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_fmix
        (v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
         rate_rmix);

    if (nodetype_data->flags & LINK_ACCESS) {
    } else {
	struct x1f4_ftsl_type *ftsl_data;

	ftsl_data = part(screen)->ftsl_blaw;
	if (ftsl_data) {
	    ftsl_data->linetext_data = linetext_data;
	    ftsl_data->type = nodetype_data->code;
	    part(screen)->ftsl_blaw = ftsl_data + 1;
	}
    }

    if (0) {
    } else {
	struct x1f4_ftsl_type *ftsl_data;

	ftsl_data = part(screen)->ftsl_rlaw;
	if (ftsl_data) {
	    ftsl_data->linetext_data = linetext_data;
	    ftsl_data->type = nodetype_data->code;
	    part(screen)->ftsl_rlaw = ftsl_data + 1;
	}
    }
}


static void
line_smap(v_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


static void
line_sset(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_POST_FLAT | X1f4_E4_POST_XSET;
    *line++ = 0;

    *args = line;

    linetext_data->function.type = screen(screen)->link_l.type;
}


static void
line_wmap(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_CASE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


static void
line_xmix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_xmix
	(v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
	 rate_xmix);
}


static void
line_xpix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_xsix
	(v_case_args_____2, screen(screen)->link_l.type,
	 ((struct lxdash_type *)
	  ((struct lxtext_type *)
	   linetext_data->context)->text)->rule_f.cxbend + 1, rate_xpix);
}


static void
line_xsix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_xsix
	(v_case_args_____2, screen(screen)->link_l.type,
	 ((struct lxdash_type *)
	  ((struct lxtext_type *)
	   linetext_data->context)->text)->rule_f.cxbend + 0, rate_xsix);
}


static void
line_xvix(v_case_args_____1)
{
    _libx1f4i0_lxcall_line_ymix
	(v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
	 &part(screen)->ftca_xlaw, rate_xvix);
}


static void
lock_gmix(v_case_args_____1)
{
    _libx1f4i0_lxcall_lock_wmix
        (v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
	 (void *) &part(screen)->fpdetail_slot[0].ftsl_data,
         ((struct lxdash_type *)
          ((struct lxtext_type *)
           linetext_data->context)->text)->rule_f.cxseek + 0, turn_gmix);
}


static void
lock_lmix(v_case_args_____1)
{
    _libx1f4i0_lxcall_lock_wmix
        (v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
	 (void *) &part(screen)->fpdetail_slot[1].ftsl_data,
         ((struct lxdash_type *)
          ((struct lxtext_type *)
           linetext_data->context)->text)->rule_f.cxseek + 3, turn_lmix);
}


static void
lock_omix(v_case_args_____1)
{
    _libx1f4i0_lxcall_lock_wmix
        (v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
	 (void *) &part(screen)->fpdetail_slot[2].ftsl_data,
         ((struct lxdash_type *)
          ((struct lxtext_type *)
           linetext_data->context)->text)->rule_f.cxseek + 2, turn_omix);
}


static void
lock_umix(v_case_args_____1)
{
    _libx1f4i0_lxcall_lock_wmix
        (v_case_args_____2, screen(screen)->link_l.type, X1f4_E4_MODE,
	 (void *) &part(screen)->fpdetail_slot[3].ftsl_data,
         ((struct lxdash_type *)
          ((struct lxtext_type *)
           linetext_data->context)->text)->rule_f.cxseek + 1, turn_umix);
}


static void
rail_plus(struct x1f4_linetext_type *linetext_data,
	  struct lxdash_type *lxdash_data,
	  const struct x1f4_operator_type *rail_p)
{
    struct x1f4_2ndscope_type *scope2nd_data;
    struct x1f4_operator_type *operator_data;

    operator_data = lxdash_data->link_f.side;
    scope2nd_data = lxdash_data->link_f.data;

    lxdash_data->link_f.data = scope2nd_data + 1;
    lxdash_data->link_f.side = operator_data + 1;
    *operator_data = *rail_p;
    operator_data->args = linetext_data->function.args + 1;
    operator_data->type = linetext_data->function.type;
    operator_data->extension2 = scope2nd_data;
    scope2nd_data->bits = 0;
    scope2nd_data->line = linetext_data;
}


static void
themed__l(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;

    *args = line;

    linetext_data->function.type = screen(screen)->link_l.type;
}


static void
themed_ll(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = screen(screen)->link_l.type;

    *args = line;

    linetext_data->function.type = screen(screen)->link_l.type;
}


static void
themed_lm(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.type = screen(screen)->link_l.type;
}


int
x1f4_init_lxdash(void **lxdash, unsigned bits,
		 const struct screen_type *screen_data)
{
    int (*link)(void *, void **, unsigned), status;
    void *line, *text;

    if (bits & CODELINK_LINK) {
	link = screen_data->lock_w.link;
	text = screen_data->lock_w.data;
    } else {
	link = _x1f4_e4_link_data;
	text = (void *) 0;
    }

    status = link(text, &line, sizeof(struct lxdash_type));
    if (status) {
	status = LINK_ERROR;
    } else {
	status = init_line(line, bits, screen_data);
	if (status) {
	    if (bits & CODELINK_LINK) {
		screen_data->lock_w.free(text, line);
	    } else {
		_x1f4_e4_free_data(text, line);
	    }
	} else {
	    *lxdash = line;
	}
    }

    return status;
}
