/*
 * lxdash-e.d.c
 * Copyright (C) 2008-2013, 2015, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <cl.h>
#include <d_fset.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>
#include <trans.h>

#define dxdash(line) \
    ((struct dxdash_type *) (line))

int
x1f4_pull_lxdash(void *subtext, void *bqpp, void *dxdash,
		 const void *line, struct trans_type *trans_data,
		 struct x1f4_caselink_type **caselink)
{
    int status;
    void *becca[6];

    becca[0] = subtext;
    becca[1] = NULL;
    becca[2] = dxdash;
    becca[3] = bqpp;
    becca[4] = trans_data;
    becca[5] = *caselink;

    status = _libx1f4i0_line_lxfset
	(dxdash(dxdash)->dash, dxdash(line)->dash, _libx1f4i0_lxdash_copy_link,
	 _libx1f4i0_lxdash_free_link, becca);
    if (status) {
	status = _libx1f4i0_lxdash_stat_line(subtext, 0, status);
    } else {
	dxdash(dxdash)->size = dxdash(line)->size;
    }

    *caselink = becca[5];

    return status;
}
