/*
 * lxdash-l.m.c
 * Copyright (C) 2008-2015, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <fd.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

int
_libx1f4i0_lxdash_m_logique(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    struct lxdash_type *lxdash_data;
    void *dash, *data;

    dxdash_data = I_LINE(input[0]);

    lxdash_data = context;

    effect.mode = I_MODE(input[1]);

    dash = dxdash_data->dash;

    status = x1f4_find_lxfset(dash, &effect, &data);
    if (status) {
	struct effect_type defect;
	void *text;

	defect = *(struct effect_type *) data;

	effect.mode = I_MODE(input[2]);

	status = x1f4_post_lxfset(dash, &effect, &text);
	if (status) {
	    do {
		if (status == X1f4_BQFSET_EVER_MATCH) {
		    if (effect.mode ^ I_MODE(input[1])) {
		    } else {
			status = 0;
			if (1) {
			    break;
			}
		    }
		}

		status = _libx1f4i0_lxdash_stat_text
		    (lxdash_data, status, effect.mode);
	    } while (0);
	} else {
	    struct effect_type *effect_text;

	    effect_text = text;

	    *effect_text = defect;
	    effect_text->mode = effect.mode;

	    /*
	     * need to reacquire address, as the data structure was modified.
	     */
	    status = x1f4_find_lxfset(dash, &defect, &data);
	    if (status) {
		effect_text = data;

		effect_text->link = ~0;

		status = _libx1f4i0_cast_lxfset(dash, &defect);
		if (status) {
		    status =
			_libx1f4i0_lxdash_stat_line(lxdash_data, 0, status);
		}
	    } else {
		status = _libx1f4i0_lxdash_stat_line(lxdash_data, 0, status);
	    }
	}
    } else {
	status = _libx1f4i0_lxdash_stat_miss(lxdash_data, effect.mode);
    }

    return status;
}
