/*
 * lxdash-u.r.c
 * Copyright (C) 2008-2013, 2015, 2016, 2018, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <d_fset.h>
#include <e4.h>
#include <lxcall.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

int
_libx1f4i0_lxdash_r_class_u(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    struct lxdash_type *lxdash_data;
    struct lxtext_type *lxtext_data;
    void *data;

    dxdash_data = I_LINE(input[0]);

    lxtext_data = context;

    lxdash_data = lxtext_data->text;

    effect.mode = I_MODE(input[1]);

    status = x1f4_find_lxfset(dxdash_data->dash, &effect, &data);
    if (status) {
	do {
	    struct effect_type *effect_data;
	    unsigned link;

	    effect_data = data;

	    link = effect_data->link;
	    if (~link) {
		int (*free)(void *, void *, struct excase_type **,
			    const struct excase_type *);
		struct lxtext_type *lxtext_link;

		lxtext_link =
		    (struct lxtext_type *) lxdash_data->link_f.text + link;

		free = lxtext_link->lxtype.free;
		if (free) {
		    status = free
			(lxtext_link->lxtype.context,
			 I_USER(&effect_data->fxdata), NULL,
			 lock_excase(dxdash_data));
		    if (status) {
			break;
		    }
		} else {
		    status = 0;
		}
	    } else {
		status = 0;
	    }

	    if (0) {
	    } else {
		X1f4_E4_C_USER trip;

		effect_data->type = lxtext_data->lxtype.code;

		link = lxtext_data
		    - (struct lxtext_type *) lxdash_data->link_f.text;

		effect_data->link = link;

		trip = I_USER(input[2]);

		l_USER(trip, &effect_data->fxdata);
		l_USER(trip, output);
	    }
	} while (0);
    } else {
	status = _libx1f4i0_lxdash_stat_miss(lxdash_data, effect.mode);
    }

    return status;
}
