/*
 * lxdata-d.c.c
 * Copyright (C) 2008-2011, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <lxdata-types.h>

#define I_DATA(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdata_p_derived(void *context, void *output, void **input)
{
    char *s, *v;
    struct dxdata_type *dxdata_data, *dxdata_text;
    unsigned pass, size;

    dxdata_data = I_DATA(input[0]);
    dxdata_text = I_DATA(input[1]);

    pass = dxdata_data->length;
    size = dxdata_text->length;

    if (pass < size) {
	size = pass;
    } else {
	pass = size;
    }

    s = dxdata_data->string;
    v = dxdata_text->string;

    for (; pass; pass--) {
	if (*s ^ *v) {
	    break;
	} else {
	    s++;
	    v++;
	}
    }

    l_MODE(size - pass, output);

    return 0;
}
