/*
 * lxdata-inter.h
 * Copyright (C) 2008-2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxdata_inter_H__
#define __LIBx1f4_lxdata_inter_H__

#include <dt.h>
#include <e4.h>
#include <lxdata-types.h>
#include <lxmode.h>
#include <lxwide.h>
#include <nl.h>
#include <nt.h>
#include <progress.h>
#include <ix.h>

#define _libx1f4i0_lxdata_land_data	x1f4_land_dxdata

#define _libx1f4i0_lxdata_bset_data	x1f4_bset_lxdata
#define _libx1f4i0_lxdata_clip_data	x1f4_clip_lxdata
#define _libx1f4i0_lxdata_copy_data	x1f4_copy_lxdata
#define _libx1f4i0_lxdata_dset_data	x1f4_dset_lxdata
#define _libx1f4i0_lxdata_fini_data	x1f4_fini_lxdata
#define _libx1f4i0_lxdata_flat_data	x1f4_flat_lxdata
#define _libx1f4i0_lxdata_fold_data	x1f4_fold_lxdata
#define _libx1f4i0_lxdata_free_data	x1f4_free_lxdata
#define _libx1f4i0_lxdata_fset_data	x1f4_fset_lxdata
#define _libx1f4i0_lxdata_init_data	x1f4_init_lxdata
#define _libx1f4i0_lxdata_kate_data	x1f4_kate_lxdata
#define _libx1f4i0_lxdata_lead_data	x1f4_lead_lxdata
#define _libx1f4i0_lxdata_line_data	x1f4_line_lxdata
#define _libx1f4i0_lxdata_link_data	x1f4_link_lxdata
#define _libx1f4i0_lxdata_lock_data	x1f4_lock_lxdata
#define _libx1f4i0_lxdata_near_data	x1f4_near_lxdata
#define _libx1f4i0_lxdata_node_data	x1f4_node_lxdata
#define _libx1f4i0_lxdata_pass_data	x1f4_pass_lxdata
#define _libx1f4i0_lxdata_post_data	x1f4_post_lxdata
#define _libx1f4i0_lxdata_rule_data	x1f4_rule_lxdata
#define _libx1f4i0_lxdata_seek_data	x1f4_seek_lxdata
#define _libx1f4i0_lxdata_slip_data	x1f4_slip_lxdata
#define _libx1f4i0_lxdata_suit_data	x1f4_suit_lxdata
#define _libx1f4i0_lxdata_tile_data	x1f4_tile_lxdata
#define _libx1f4i0_lxdata_tune_data	x1f4_tune_lxdata
#define _libx1f4i0_lxdata_type_data	x1f4_type_lxdata
#define _libx1f4i0_lxdata_uset_data	x1f4_uset_lxdata
#define _libx1f4i0_lxdata_wrap_data	x1f4_wrap_lxdata

#define __types_lock(lxdata) \
    (&((struct lxdata_type *) (lxdata))->ever_m.nice_1.east_1)

#define __types_long(lxdata) \
    (&((struct lxdata_type *) (lxdata))->ever_m.nice_1.east_1)

#define _libx1f4i0_lxdata_stat_base(___l, ___1) \
    _libx1f4i0_lxlock_stat_base(__types_lock((___l)), (___1))
#define _libx1f4i0_lxdata_stat_free(___l, ___1) \
    _libx1f4i0_lxlock_stat_free(__types_lock((___l)), (___1))
#define _libx1f4i0_lxdata_stat_line(___l, ___1) \
    _libx1f4i0_lxlock_stat_line(__types_lock((___l)), (___1))
#define _libx1f4i0_lxdata_stat_link(___l) \
    _libx1f4i0_lxlock_stat_link(__types_lock((___l)))
#define _libx1f4i0_lxdata_stat_mode(___l) \
    _libx1f4i0_lxlock_stat_mode(__types_lock((___l)))
#define _libx1f4i0_lxdata_stat_roll(___l, ___1, ___2) \
    _libx1f4i0_lxlock_stat_roll(__types_lock((___l)))
#define _libx1f4i0_lxdata_stat_zero(___l) \
    _libx1f4i0_lxlock_stat_zero(__types_lock((___l)))

extern int _libx1f4i0_lxdata_a_derived(void *, void *, void **);
extern int _libx1f4i0_lxdata_a_forward(void *, void *, void **);
extern int _libx1f4i0_lxdata_a_logique(void *, void *, void **);
extern int _libx1f4i0_lxdata_a_pending(void *, void *, void **);
extern int _libx1f4i0_lxdata_b_logique(void *, void *, void **);
extern int _libx1f4i0_lxdata_b_pending(void *, void *, void **);
extern int _libx1f4i0_lxdata_bset_data
    (void *, const struct x1f4_operator_type **);
extern int _libx1f4i0_lxdata_bill_text(void *, void *, unsigned, void *);
extern int _libx1f4i0_lxdata_c_derived(void *, void *, void **);
extern int _libx1f4i0_lxdata_c_forward(void *, void *, void **);
extern int _libx1f4i0_lxdata_c_logique(void *, void *, void **);
extern int _libx1f4i0_lxdata_c_pending(void *, void *, void **);
extern int _libx1f4i0_lxdata_clip_data
    (unsigned, const void *, struct x1f4_nodetype_type **, int *);
extern int _libx1f4i0_lxdata_clip_long(void *, void *, unsigned, unsigned);
extern int _libx1f4i0_lxdata_copy_data
    (void *, void *, void **, const void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxdata_cpderived(void *, void *, void **);
extern int _libx1f4i0_lxdata_d_centric(void *, void *, void **);
extern int _libx1f4i0_lxdata_d_forward(void *, void *, void **);
extern int _libx1f4i0_lxdata_d_logique(void *, void *, void **);
extern int _libx1f4i0_lxdata_d_pending(void *, void *, void **);
extern int _libx1f4i0_lxdata_dbcentric(void *, void *, void **);
extern int _libx1f4i0_lxdata_dbforward(void *, void *, void **);
extern int _libx1f4i0_lxdata_dfcentric(void *, void *, void **);
extern int _libx1f4i0_lxdata_dfforward(void *, void *, void **);
extern int _libx1f4i0_lxdata_drop_line
    (void *, void *, void *, const char *,
     void (*)(unsigned char *, unsigned *, unsigned *));
extern int _libx1f4i0_lxdata_dset_data
    (void *, const struct x1f4_datatype_type **);
extern int _libx1f4i0_lxdata_e_derived(void *, void *, void **);
extern int _libx1f4i0_lxdata_e_forward(void *, void *, void **);
extern int _libx1f4i0_lxdata_e_logique(void *, void *, void **);
extern int _libx1f4i0_lxdata_e_pending(void *, void *, void **);
extern int _libx1f4i0_lxdata_f_derived(void *, void *, void **);
extern int _libx1f4i0_lxdata_f_forward(void *, void *, void **);
extern int _libx1f4i0_lxdata_f_logique(void *, void *, void **);
extern int _libx1f4i0_lxdata_f_sequent(void *, void *, void **);
extern int _libx1f4i0_lxdata_g_derived(void *, void *, void **);
extern int _libx1f4i0_lxdata_g_forward(void *, void *, void **);
extern int _libx1f4i0_lxdata_fini_data(void **);
extern int _libx1f4i0_lxdata_flat_data(void *, void **);
extern int _libx1f4i0_lxdata_fold_data(void *, unsigned *);
extern int _libx1f4i0_lxdata_free_data
    (void *, void *, struct x1f4_nodelink_type **,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxdata_fset_data
    (void *, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxdata_i_derived(void *, void *, void **);
extern int _libx1f4i0_lxdata_i_forward(void *, void *, void **);
extern int _libx1f4i0_lxdata_i_logique(void *, void *, void **);
extern int _libx1f4i0_lxdata_i_sequent(void *, void *, void **);
extern int _libx1f4i0_lxdata_init_data
    (void **, unsigned, const struct screen_type *);
extern int _libx1f4i0_lxdata_j_derived(void *, void *, void **);
extern int _libx1f4i0_lxdata_kate_data(void *, void *, int, unsigned);
extern int _libx1f4i0_lxdata_l_derived(void *, void *, void **);
extern int _libx1f4i0_lxdata_l_forward(void *, void *, void **);
extern int _libx1f4i0_lxdata_l_logique(void *, void *, void **);
extern int _libx1f4i0_lxdata_l_nearest(void *, void *, void **);
extern int _libx1f4i0_lxdata_l_pending(void *, void *, void **);
extern int _libx1f4i0_lxdata_l_sequent(void *, void *, void **);
extern int _libx1f4i0_lxdata_land_data(void *, void *, const void *, unsigned);
extern int _libx1f4i0_lxdata_lead_data(void *, void **);
extern int _libx1f4i0_lxdata_line_data(void *, void **);
extern int _libx1f4i0_lxdata_link_data(void *, void **);
extern int _libx1f4i0_lxdata_lock_data
    (void *, int, int, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxdata_m_derived(void *, void *, void **);
extern int _libx1f4i0_lxdata_m_forward(void *, void *, void **);
extern int _libx1f4i0_lxdata_m_logique(void *, void *, void **);
extern int _libx1f4i0_lxdata_m_pending(void *, void *, void **);
extern int _libx1f4i0_lxdata_n_derived(void *, void *, void **);
extern int _libx1f4i0_lxdata_n_forward(void *, void *, void **);
extern int _libx1f4i0_lxdata_n_sequent(void *, void *, void **);
extern int _libx1f4i0_lxdata_near_data(void *);
extern int _libx1f4i0_lxdata_node_data
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxdata_p_derived(void *, void *, void **);
extern int _libx1f4i0_lxdata_p_forward(void *, void *, void **);
extern int _libx1f4i0_lxdata_p_logique(void *, void *, void **);
extern int _libx1f4i0_lxdata_p_pending(void *, void *, void **);
extern int _libx1f4i0_lxdata_p_sequent(void *, void *, void **);
extern int _libx1f4i0_lxdata_part_data(void *, void *, unsigned);
extern int _libx1f4i0_lxdata_pass_data
    (void *, struct x1f4_progress_type **, char **);
extern int _libx1f4i0_lxdata_post_data
    (void *, void **, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxdata_q_centric(void *, void *, void **);
extern int _libx1f4i0_lxdata_r_derived(void *, void *, void **);
extern int _libx1f4i0_lxdata_r_forward(void *, void *, void **);
extern int _libx1f4i0_lxdata_r_logique(void *, void *, void **);
extern int _libx1f4i0_lxdata_r_sequent(void *, void *, void **);
extern int _libx1f4i0_lxdata_rule_data
    (void *, void *, unsigned, unsigned, void *);
extern int _libx1f4i0_lxdata_rule_text
    (void *, void *, unsigned, unsigned, void *);
extern int _libx1f4i0_lxdata_s_derived(void *, void *, void **);
extern int _libx1f4i0_lxdata_s_forward(void *, void *, void **);
extern int _libx1f4i0_lxdata_s_generic(void *, void *, void **);
extern int _libx1f4i0_lxdata_s_harsher(void *, void *, void **);
extern int _libx1f4i0_lxdata_s_logique(void *, void *, void **);
extern int _libx1f4i0_lxdata_s_nearest(void *, void *, void **);
extern int _libx1f4i0_lxdata_s_ongoing(void *, void *, void **);
extern int _libx1f4i0_lxdata_s_pending(void *, void *, void **);
extern int _libx1f4i0_lxdata_s_sequent(void *, void *, void **);
extern int _libx1f4i0_lxdata_seek_data(const void *);
extern int _libx1f4i0_lxdata_selogique(void *, void *, void **);
extern int _libx1f4i0_lxdata_side_data(void *, void *);
extern int _libx1f4i0_lxdata_slip_data(void *, void **);
extern int _libx1f4i0_lxdata_splogique(void *, void *, void **);
extern int _libx1f4i0_lxdata_sqlogique(void *, void *, void **);
extern int _libx1f4i0_lxdata_stat_deck(void *, unsigned, long);
extern int _libx1f4i0_lxdata_stat_hang(void *);
extern int _libx1f4i0_lxdata_stat_hold(void *, unsigned, long, long);
extern int _libx1f4i0_lxdata_stat_late(void *);
extern int _libx1f4i0_lxdata_stat_null(void *);
extern int _libx1f4i0_lxdata_stat_sign(void *, long);
extern int _libx1f4i0_lxdata_stat_time(void *, unsigned, long);
extern int _libx1f4i0_lxdata_suit_data(void *, void *, void *);
extern int _libx1f4i0_lxdata_t_derived(void *, void *, void **);
extern int _libx1f4i0_lxdata_t_forward(void *, void *, void **);
extern int _libx1f4i0_lxdata_t_logique(void *, void *, void **);
extern int _libx1f4i0_lxdata_t_pending(void *, void *, void **);
extern int _libx1f4i0_lxdata_tile_data
    (void **, unsigned, struct x1f4_lxwide_type *, unsigned, const void *);
extern int _libx1f4i0_lxdata_tune_data(void *);
extern int _libx1f4i0_lxdata_type_data(struct x1f4_nodetype_type *, int);
extern int _libx1f4i0_lxdata_u_nearest(void *, void *, void **);
extern int _libx1f4i0_lxdata_uset_data
    (void *, const struct x1f4_operator_type **);
extern int _libx1f4i0_lxdata_wrap_data(void *, struct x1f4_indexset_type *);
extern int _libx1f4i0_lxdata_x_pending(void *, void *, void **);
extern int _libx1f4i0_lxdata_y_logique(void *, void *, void **);
extern int _libx1f4i0_lxdata_zbcentric(void *, void *, void **);
extern int _libx1f4i0_lxdata_zfcentric(void *, void *, void **);

#endif				/* __LIBx1f4_lxdata_inter_H__ */
