/*
 * lxdata-p.e.c
 * Copyright (C) 2008-2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <lxdata-drive.h>
#include <lxdata-inter.h>
#include <lxdata-types.h>

int
_libx1f4i0_lxdata_e_pending(void *context, void *output, void **input)
{
    int status;

    do {
	X1f4_E4_C_MODE lead, post;
	struct dxdata_type *dxdata_data;
	unsigned size;

	dxdata_data = I_DATA(input[0]);

	size = dxdata_data->length;

	lead = I_MODE(input[1]);

	size++;

	if (lead < 0) {
	    if ((X1f4_E4_C_MODE) size < -lead) {
		status = _libx1f4i0_lxdata_stat_deck(context, size, -lead);
		if (1) {
		    break;
		}
	    } else {
		lead = size + lead;
	    }
	} else {
	    if (lead < size) {
	    } else {
		status = _libx1f4i0_lxdata_stat_deck(context, size, lead);
		if (1) {
		    break;
		}
	    }
	}

	size--;

	post = I_MODE(input[2]);

	post += lead;
	if (post < 0) {
	    post = 0;
	} else {
	    if (post < size) {
	    } else {
		post = size;
	    }
	}

	if (lead ^ post) {
	    if (post < lead) {
		X1f4_E4_C_MODE mode;

		mode = post;
		post = lead;
		lead = mode;
	    }

	    status = _libx1f4i0_lxdata_clip_long
		(context, dxdata_data, lead, post - 1);
	    if (status) {
		break;
	    }
	} else {
	    status = 0;
	}

	l_DATA(dxdata_data, output);
    } while (0);

    return status;
}
