/*
 * lxdata-p.m.c
 * Copyright (C) 2008-2010, 2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxcall.h>
#include <lxdata-types.h>

#define I_DATA(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define l_TEXT(e, output) \
    {									      \
	X1f4_E4_C_TEXT *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

#define lxdata(lxdata) \
    ((struct lxdata_type *) (lxdata))

int
_libx1f4i0_lxdata_m_pending(void *context, void *output, void **input)
{
    int status;
    struct dxdata_type *dxdata_data;

    dxdata_data = I_DATA(input[1]);

    status = _libx1f4i0_lxcall_swap_text
	(&lxdata(context)->ever_a, *input, dxdata_data->string,
	 dxdata_data->length + 1);
    if (status) {
    } else {
	l_TEXT(I_TEXT(*input), output);
    }

    return status;
}
