/*
 * lxdata-s.i.c
 * Copyright (C) 2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxcall.h>
#include <lxdata-inter.h>
#include <lxdata-types.h>
#include <lxfile.h>

#define lxdata(lxdata) \
    ((struct lxdata_type *) (lxdata))

int
_libx1f4i0_lxdata_i_sequent(void *context, void *output, void **input)
{
    int status;
    void *dxfile, *lxfile;

    lxfile = lxdata(context)->link_l.file;

    status = x1f4_link_lxfile(lxfile, &dxfile);
    if (status) {
    } else {
	status = x1f4_line_lxfile(lxfile, &dxfile);
	if (status) {
	} else {
	    int excess;
	    const struct x1f4_linetext_type *f_b_affix;
	    struct x1f4_nodetype_type nodetype;

	    nodetype.context = lxfile;
	    nodetype.lead = x1f4_lead_lxfile;
	    nodetype.slip = x1f4_slip_lxfile;

	    f_b_affix = lxdata(context)->rule_l.f_b_affix;

	    status = x1f4_auto_node
		(&lxdata(context)->link_v, &lxdata(context)->link_e,
		 &nodetype, &dxfile, output);
	    if (status || !f_b_affix) {
	    } else {
		void *track[3];

		track[0] = input[-1];
		track[1] = &dxfile;
		track[2] = input[0];

		status = f_b_affix->function.function
		    ((void *) f_b_affix->context, output, track + 1);
	    }

	    excess = x1f4_flat_lxfile(lxfile, &dxfile);
	    if (excess) {
		status = _libx1f4i0_lxcall_land_slip(excess, status);
	    }
	}
    }

    return status;
}
