/*
 * lxdata-types.h
 * Copyright (C) 2008-2014, 2016, 2017, 2019-2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxdata_types_H__
#define __LIBx1f4_lxdata_types_H__

#include <lxdata-config.h>

#include <time.h>

#include <dt.h>
#include <frame.h>
#include <it.h>
#include <lxmode.h>
#include <track.h>
#if __TRANS_DATA_LX_DEFINITION__
# include <trans.h>
#endif				/* __TRANS_DATA_LX_DEFINITION__ */

/*
 * NOTES
 *
 *.it is assumed no cycles can form through objects of the -data- type.  The
 * assumption is made by other data types (-file-).
 */
typedef struct dxdata_type {
    char *string;
    unsigned call, length;
} dxdata_type;

typedef struct lxdata_type {
    struct lxmode_type ever_m;
    struct {
	void *file;
    } link_l;
    struct x1f4_iturn_type link_p;
    struct x1f4_composer_type link_q;
    struct {
	struct x1f4_linetext_type *b_draft, *b_string;
    } late_f;
#if 0
    struct {
	struct x1f4_nodetype_type nodetype[1];
    } link_y;
#endif				/* 0 */
    struct {
	const void *f_b_affix;
    } rule_l;
} lxdata_type;

typedef struct screen_type {
    struct x1f4_track_type lock_e;
    struct {
	const struct x1f4_eelookup_type *eelookup_data;
    } lock_g;
    struct {
	int type;
    } lock_f;
    struct {
	int type;
    } link_l;
    struct x1f4_trans_type lock_m;
    struct x1f4_iturn_type lock_p;
    struct x1f4_composer_type lock_q;
    struct x1f4_frame_type lock_v;
    struct x1f4_trans_type lock_w;
} screen_type;

#endif				/* __LIBx1f4_lxdata_types_H__ */

