/*
 * lxdecq-m.j.s.0.c
 * Copyright (C) 2008-2010, 2013-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <f_list.h>
#include <lxdecq-drive.h>
#include <lxdecq-inter.h>
#include <lxdecq-types.h>

int
_libx1f4i0_lxdecq_j0classsm(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxlist_type *dxlist_data;
    void *data;

    cxbend_data = context;

    dxlist_data = I_LIST(input[1]);

    status = cxbend_data->pick(dxlist_data->list, &data);
    if (status) {
	if (status == X1f4_DLLIST_DECK_ERROR) {
	    l_MODE(0, output);
	    if (1) {
		status = 0;
	    }
	} else {
	    status = _libx1f4i0_lxdecq_stat_list(cxbend_data->list, 0, status);
	}
    } else {
	unsigned type;

	type = effect_type(data);
	if (type != X1f4_E4_MODE) {
	    l_MODE(0, output);
	} else {
	    X1f4_E4_C_MODE fast;

	    fast = E_MODE(data);

	    status = cxbend_data->roll(dxlist_data->list);
	    if (status) {
		status = _libx1f4i0_lxdecq_stat_list
		    (cxbend_data->list, 0, status);
	    } else {
		l_MODE(1, output);

		l_MODE(fast, input[0]);
	    }
	}
    }

    return status;
}
