/*
 * lxdecq-v.p.f.c
 * Copyright (C) 2008-2011, 2013, 2014, 2017, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxdecq-config.h>

#include <stddef.h>

#include <e4.h>
#include <f_list.h>
#include <lxdecq-drive.h>
#include <lxdecq-inter.h>
#include <lxdecq-types.h>

int
_libx1f4i0_lxdecq_pfclass_v(void *context, void *output, void **input)
{
    int status;

    do {
	struct dxlist_type *dxlist_data;
	struct lxtext_type *lxtext_data;

	lxtext_data = context;

	dxlist_data = I_LIST(input[0]);

	if (1) {
	    int (*copy) (void *, void *, void **, const void *,
			 const struct excase_type *);

	    copy = lxtext_data->lxtype.copy;

	    {
		void *slip;

		status = copy
		    (lxtext_data->lxtype.context, NULL, &slip,
		     I_USER(input[1]), lock_excase(dxlist_data));
		if (status) {
		    break;
		} else {
		    unsigned type;
		    void *data;

		    type = lxtext_data->lxtype.code;

		    status = _libx1f4i0_head_dllist(dxlist_data->list, &data);
		    if (status) {
			status = _libx1f4i0_lxdecq_stat_list
			    (lxtext_data->text, 0, status);

			lxtext_data->lxtype.free
			    (lxtext_data->lxtype.context,
			     slip, NULL, lock_excase(dxlist_data));
		    } else {
			unsigned link;

			type_effect(data, type);

			link = lxtext_data
			    - ((struct lxtext_type *)
			       ((struct lxdecq_type *)
				lxtext_data->text)->link_f.text);

			link_effect(data, link);

			dxlist_data->size++;

			l_USER(slip, effect_data(data));
		    }
		}
	    }
	}
    } while (0);

    return status;
}
