/*
 * lxfile-f.y.c
 * Copyright (C) 2008-2010, 2013, 2015, 2016, 2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <file.h>
#include <lxfile-defs.h>
#include <lxfile-drive.h>
#include <lxfile-inter.h>
#include <lxfile-types.h>
#include <trans.h>

int
_libx1f4i0_lxfile_y_forward(void *context, void *output, void **input)
{
    int pick, status;
    struct dxfile_type *dxfile_data;

    dxfile_data = I_FILE(input[0]);

    if (dxfile_data->mode != READ_CLASS) {
	status = _libx1f4i0_lxfile_stat_turn(context, dxfile_data);
    } else {
	status = _libx1f4i0_pick_ifile(dxfile_data->file, &pick);
	if (status) {
	    if (0) {
	    } else {
		status = _libx1f4i0_lxfile_stat_file(context, status);
	    }
	} else {
	    l_MODE(pick, output);
	}
    }

    return status;
}
