/*
 * lxfile-n.s.c
 * Copyright (C) 2008, 2009, 2010, 2013, 2016, 2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <file.h>
#include <lxfile-defs.h>
#include <lxfile-drive.h>
#include <lxfile-inter.h>
#include <lxfile-types.h>
#include <trans.h>

int
_libx1f4i0_lxfile_s_nearest(void *context, void *output, void **input)
{
    int status;

    do {
	struct dxfile_type *dxfile_data;
	struct lxfile_type *lxfile_data;
	void *file;

	dxfile_data = I_FILE(input[0]);

	lxfile_data = context;

	file = dxfile_data->file;
	if (1) {
	    unsigned size;

	    if (dxfile_data->mode != READ_CLASS) {
		status = _libx1f4i0_lxfile_stat_turn(lxfile_data, dxfile_data);
		if (1) {
		    break;
		}
	    }

	    status = _libx1f4i0_slip_ifile(file, &size);
	    if (status) {
		if (status == FILE_OVER_CLASS) {
		    status = 0;

		    l_MODE(-1, output);
		} else {
		    status = _libx1f4i0_lxfile_stat_file(lxfile_data, status);
		}
	    } else {
		l_MODE(size, output);
	    }
	}
    } while (0);

    return status;
}
