/*
 * lxlead.h
 * Copyright (C) 2008-2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxlead_H__
#define __LIBx1f4_lxlead_H__

#include <cl.h>
#include <ln.h>
#include <nl.h>
#include <nt.h>
#include <trans.h>

extern int x1f4_beta_lxlead
    (void *, struct x1f4_caselink_type *, struct trans_type *);
extern int x1f4_call_lxlead(struct x1f4_nodelink_type *);
extern int x1f4_case_lxlead
    (struct x1f4_nodelink_type **, const void *);
extern int x1f4_fail_lxlead(struct x1f4_nodelink_type *);
extern int x1f4_long_lxlead
    (struct x1f4_nodelink_type **, const void *);
extern int x1f4_lose_lxlead(struct x1f4_caselink_type *, struct trans_type *);
extern int x1f4_mind_lxlead
    (struct x1f4_nodelink_type **, void *);
extern int x1f4_move_lxlead
    (void *, void *, void *, const struct x1f4_nodelink_type *,
     const struct x1f4_nodelink_type *);
extern int x1f4_near_lxlead
    (struct x1f4_nodelink_type **, struct x1f4_nodelink_type **,
     struct x1f4_nodelink_type *);
extern int x1f4_pass_lxlead
    (struct x1f4_nodelink_type **, struct x1f4_nodelink_type *);
extern int x1f4_pull_lxlead
    (void *, void *, const void *, int *, struct trans_type *,
     struct x1f4_caselink_type **, struct x1f4_nodetype_type *,
     const struct x1f4_nodelink_type *);
extern int x1f4_seek_lxlead
    (struct x1f4_nodelink_type **, const void *, unsigned);
extern int x1f4_side_lxlead
    (struct x1f4_nodelink_type **, const void *);
extern int x1f4_slip_lxlead(struct x1f4_nodelink_type *);

#endif				/* __LIBx1f4_lxlead_H__ */
