/*
 * lxline-drive.h
 * Copyright (C) 2016, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxline_drive_H__
#define __LIBx1f4_lxline_drive_H__

#include <e4.h>
#include <fd.h>
#include <lxline-types.h>

#define I_BILL(t)			(*((X1f4_E4_C_BILL *) (t)))
#define I_DATA(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_REAL(t)			(*((X1f4_E4_C_REAL *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define E_BILL(___e)			I_BILL(effect_data(___e))
#define E_MODE(___e)			I_MODE(effect_data(___e))
#define E_REAL(___e)			I_REAL(effect_data(___e))
#define E_TEXT(___e)			I_TEXT(effect_data(___e))
#define E_USER(___e)			I_USER(effect_data(___e))

#define Q_LINE(___q)			((struct dxline_type *) I_LINE(___q))

#define byte(miss)			((unsigned char *) (miss))

#define __drive_link(___d) \
    ((___d)[4] << 030 | (___d)[5] << 020 | (___d)[6] << 010 | (___d)[7])
#define __drive_type(___d) \
    ((___d)[0] << 030 | (___d)[1] << 020 | (___d)[2] << 010 | (___d)[3])

#define effect_size			(sizeof(struct fxdata_type) + 8)

#define effect_data(___a)		(byte(___a) + 8)

#define effect_link(___a)		__drive_link(byte(___a))
#define effect_type(___a)		__drive_type(byte(___a))

#define link_effect(___a, ___l) \
    {									      \
	byte(___a)[4] = (___l) >> 030;					      \
	byte(___a)[5] = (___l) >> 020;					      \
	byte(___a)[6] = (___l) >> 010;					      \
	byte(___a)[7] = (___l) >> 000;					      \
    }

#define type_effect(___a, ___t) \
    {									      \
	byte(___a)[0] = (___t) >> 030;					      \
	byte(___a)[1] = (___t) >> 020;					      \
	byte(___a)[2] = (___t) >> 010;					      \
	byte(___a)[3] = (___t) >> 000;					      \
    }

#define l_LINE(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

#define l_TEXT(e, output) \
    {									      \
	X1f4_E4_C_TEXT *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

#undef effect_size

#undef effect_data

#undef effect_link
#undef effect_type

#undef link_effect

#undef type_effect

#define letter(letter) \
    ((struct letter_type *) (letter))

#define effect_size			sizeof(struct letter_type)

#define effect_data(___a)		(&letter(___a)->fxdata)

#define effect_link(___a)		(letter(___a)->link)
#define effect_type(___a)		(letter(___a)->tune)

#define link_effect(___a, ___l) \
    {									      \
	effect_link(___a) = (___l);					      \
    }

#define type_effect(___a, ___t) \
    {									      \
	effect_type(___a) = (___t);					      \
    }

typedef struct letter_type {
    int link, tune;
    struct fxdata_type fxdata;
} letter_type;

#endif				/* __LIBx1f4_lxline_drive_H__ */

