/*
 * lxline-k.e.c
 * Copyright (C) 2008-2017, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <l_note.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>
#include <lxrail.h>
#include <retain.h>

int
_libx1f4i0_lxline_e_keeping(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    void *data, *line;

    dxline_data = I_LINE(input[0]);

    cxbend_data = context;

    lxline_data = cxbend_data->line;

    line = dxline_data->line;

    status = cxbend_data->pick(line, &data);
    if (status) {
	status = _libx1f4i0_lxline_stat_line(lxline_data, 0, status);
    } else {
	status = _libx1f4i0_lxrail_post_data
	    (lxline_data, output, effect_link(data), effect_type(data),
	     effect_data(data));
	if (status) {
	} else {
#if __RETAIN_OBJECT_DATA__
# error not considered
#else
	    unsigned link;

	    link = effect_link(data);

	    if (~link) {
		struct lxtext_type *lxtext_data;

		link_effect(data, ~0);

		lxtext_data = lxline_data->link_f.text;
		lxtext_data += link;
		if (lxtext_data->lxtype.free) {
		    status = lxtext_data->lxtype.free
			(lxtext_data->lxtype.context, E_USER(data),
			 NULL, lock_excase(dxline_data));
		} else {
		}
	    }

	    if (status) {
	    } else {
		status = cxbend_data->slip(line);
		if (status) {
		    status =
			_libx1f4i0_lxline_stat_line(lxline_data, 0, status);
		} else {
		    dxline_data->size--;
		}
	    }
#endif				/* __RETAIN_OBJECT_DATA__ */
	}
    }

    return status;
}
