/*
 * lxlist-a.u.c
 * Copyright (C) 2008-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <cl.h>
#include <copy.h>
#include <e4.h>
#include <lxlead.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>
#include <nt.h>

#define becca(context) \
    ((void **) (context))
#define scope(context) \
    (becca((context)) + 2)
#define track(context) \
    (becca((context)) + 3)
#define frame(context) \
    (becca((context)) + 4)
#define class(context) \
    (becca((context)) + 5)

#define lxlist(list) \
    ((struct lxlist_type *) (list))

int
_libx1f4i0_lxlist_copy_link(void *context, void *list, const void *data)
{
    int status;
    unsigned link;

    link = effect_link(data);

    link_effect(list, effect_link(data));
    type_effect(list, effect_type(data));

    do {
	list = effect_data(list);

	if (~link) {
	    struct lxtext_type *lxtext_link;

	    lxtext_link =
		((struct lxtext_type *) lxlist(*becca(context))->link_f.text)
		+ link;

	    if (x1f4_pull_lxlead
		(*track(context), list, effect_data(data), &status,
		 *frame(context),
		 (struct x1f4_caselink_type **) class(context),
		 &lxtext_link->lxtype, lock_excase(*scope(context)))) {
		break;
	    }
	}

	status = 0;

	{
#if defined copy_trap
	    copy_trap(list, effect_data(data));
#else
	    unsigned type;

	    type = effect_type(data);

	    copy_miss(list, type, effect_data(data));
#endif				/* copy_trap */
	}
    } while (0);

    return status;

}
