/*
 * lxlist-e.w.c
 * Copyright (C) 2008-2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxlist-config.h>

#include <stddef.h>

#include <l_list.h>
#include <lxcall.h>
#include <lxlead.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

#define break_cycles			0

#define lxlist(lxlist) \
    ((struct lxlist_type *) (lxlist))

int
x1f4_slip_lxlist(void *subtext, void **data)
{
    int status;
    unsigned call;
    void *dxlist;

    dxlist = *data;

    call = lock_exlist(dxlist)->call;
    call--;
    if (call) {
	int (*miss)(void *, struct x1f4_nodelink_type **,
		    struct x1f4_nodelink_type *);

	lock_exlist(dxlist)->call = call;

	miss = lxlist(subtext)->link_r.miss;
	if (miss) {
	    status = miss
		(lxlist(subtext)->link_r.text, NULL, lock_excase(dxlist));
	} else {
	    status = x1f4_mind_lxlead(NULL, dxlist);
	}
    } else {
	int excess;

	lock_exlist(dxlist)->call = break_cycles;

	status = _libx1f4i0_lxlist_null_list(subtext, NULL, dxlist);

	excess = _libx1f4i0_lxlist_fine_list(subtext, dxlist);
	if (excess) {
	    status = _libx1f4i0_lxcall_land_slip(excess, status);
	}
    }

    return status;
}
