/*
 * lxlist-k.c.c
 * Copyright (C) 2008-2011, 2013, 2014, 2016, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_list.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

int
_libx1f4i0_lxlist_c_keeping(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxlist_type *dxlist_data;
    struct lxlist_type *lxlist_data;

    cxbend_data = context;

    lxlist_data = cxbend_data->list;

    dxlist_data = I_LIST(input[0]);

    if (!dxlist_data->size) {
	status = _libx1f4i0_lxlist_stat_null(lxlist_data);
    } else {
	void *data;

	status = cxbend_data->pick(dxlist_data->list, &data);
	if (status) {
	    status = _libx1f4i0_lxlist_stat_list(lxlist_data, 0, status);
	} else {
	    status = _libx1f4i0_lxrail_post_data
		(lxlist_data, output, effect_link(data), effect_type(data),
		 effect_data(data));
	}
    }

    return status;
}
