/*
 * lxlist-p.a.c
 * Copyright (C) 2013-2015, 2017-2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <copy.h>
#include <e4.h>
#include <exerrors.h>
#include <lxcast.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>

int
_libx1f4i0_lxlist_a_pending(void *context, void *output, void **input)
{
    int status;
    struct dxlist_type *dxlist_data;
    struct lxlist_type *lxlist_data;

    lxlist_data = context;

    dxlist_data = I_LIST(input[0]);

    if (0) {
    } else {
	struct x1f4_function_type *function_data;
	unsigned count;
	void **strip;

	strip = input[-1];

	function_data = strip[X1f4_E4_RENDITION];

	status = 0;

	count = function_data->count - 1;
	if (count) {
	    struct cxbend_type *cxbend_data;
	    struct x1f4_function_type function;
	    void *slip[3];

	    slip[0] = strip;
	    slip[1] = *input;

	    cxbend_data = lxlist_data->rule_f.cxbend + 1;

	    /*
	     * pretty error reporting:
	     */
	    function.length = 8;
	    function.name = "l_append";

	    function.args = function_data->args;

	    strip[X1f4_E4_RENDITION] = &function;

	    for (; count; count--) {
		slip[2] = *++input;
		status =
		    _libx1f4i0_lxlist_b_keeping(cxbend_data, NULL, slip + 1);
		if (status) {
		    break;
		}

		function.args++;
	    }
	}

	if (status) {
	} else {
	    l_LIST(dxlist_data, output);
	}
    }

    return status;
}

