/*
 * lxlist-x.n.c
 * Copyright (C) 2008-2011, 2013, 2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <l_list.h>
#include <lxlist-drive.h>
#include <lxlist-types.h>

#define dxlist(list) \
    ((struct dxlist_type *) (list))

#define will(miss) \
    ((struct will_type *) (miss))

typedef struct will_type {
    int (*call)(void *, int, void *);
    void *back;
} will_type;

static int type_list(void *, void *);

static int
type_list(void *will, void *slip)
{
    return will(will)->call
	(will(will)->back, effect_type(slip), effect_data(slip));
}


int
x1f4_will_lxlist(void *subtext, void *dxlist, void *back,
		 int (*call)(void *, int, void *))
{
    struct will_type will;

    will.back = back;
    will.call = call;

    return _libx1f4i0_lime_l4list(dxlist(dxlist)->list, &will, type_list);
}
