/*
 * lxlock-e.a.c
 * Copyright (C) 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <fcntl.h>
#include <unistd.h>

#include <lxlock-inter.h>

int
_libx1f4i0_lxlock_lock_link(void *lxlock, int fd)
{
    int flags, status = 0;

    flags = fcntl(fd, F_GETFL);
    if (flags == -1) {
	status = _libx1f4i0_lxlock_stat_getf(lxlock);
    } else {
	flags |= O_NONBLOCK;
	if (fcntl(fd, F_SETFL, flags) == -1) {
	    status = _libx1f4i0_lxlock_stat_setf(lxlock);
	} else {
	    int class;

	    class = fcntl(fd, F_GETFL);
	    if (class == -1) {
		status = _libx1f4i0_lxlock_stat_getf(lxlock);
	    } else {
		if (class != (flags | O_NONBLOCK)) {
		    status = _libx1f4i0_lxlock_stat_setf(lxlock);
		}
	    }
	}
    }

    return status;
}
