/*
 * lxmile-a.l.c
 * Copyright (C) 2014-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <lxcall.h>
#include <lxlead.h>
#include <lxmile-inter.h>
#include <lxmile-types.h>
#include <nl.h>

#define lxtext(text) \
    ((struct lxtext_type *) (text))

int
_libx1f4i0_lxmile_null_mile(void *lxtext, struct x1f4_nodelink_type **nodelink,
			    void *dxpart)
{
    int (*high)(void *, void *, struct x1f4_nodelink_type **), status;
    struct x1f4_nodelink_type *nodelink_data;

    if (nodelink) {
	nodelink_data = *nodelink;
    } else {
	nodelink_data = NULL;
    }

    high = lxtext(lxtext)->high;
    if (high) {
	status = high(lxtext(lxtext)->text, dxpart, &nodelink_data);
    } else {
	status = 0;
    }

    if (nodelink) {
	*nodelink = nodelink_data;
    } else {
	if (nodelink_data) {
	    int excess;

	    excess = x1f4_fail_lxlead(nodelink_data);
	    if (excess) {
		status = _libx1f4i0_lxcall_land_slip(excess, status);
	    }
	}
    }

    return status;
}
