/*
 * lxmile-e.b.c
 * Copyright (C) 2008, 2009, 2013-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <exerrors.h>
#include <lxmile-types.h>
#include <tcvset.h>

#define tccase(vset) \
    ((struct x1f4_tccase_type *) (vset))

int
x1f4_node_lxmile(void *subtext, void **copy, void *part,
		 const struct x1f4_nodelink_type *nodelink_data)
{
    int status;

    status = tccase(lock_expart(part)->text)->push
	(&lock_expart(part)->pset, &lock_expart(part)->text, nodelink_data,
	 &((struct lxmile_type *)
	   ((struct lxtext_type *) subtext)->part)->link_m);
    if (status) {
	status = X1f4_EX_CRITICAL;
    } else {
	*copy = (void *) part;

	lock_expart(part)->call++;
    }

    return status;
}
