/*
 * lxmile-types.h
 * Copyright (C) 2015, 2016, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxmile_types_H__
#define __LIBx1f4_lxmile_types_H__

#include <dt.h>
#include <integral_q.h>
#include <ln.h>
#include <lxlong.h>
#include <nl.h>

#define here_NULL                       ((void *) 0)

#define here_offsetof(type, ceil) \
    ((integral_q) (&((type *) here_NULL)->ceil))

#define lock_excase(dxpart_text) \
    ((struct x1f4_nodelink_type *) &lock_cxpart((dxpart_text))->link)

#define lock_expart(dxpart_text) \
    ((struct x1f4_nodeline_type *) &lock_cxpart((dxpart_text))->line)

#define lock_cxpart(dxpart_text) \
    ((struct x1f4_leadnode_type *)                                            \
     ((char *) (dxpart_text) - sizeof(struct x1f4_leadnode_type)))

#define near_dxpart(excase_text) \
    ((struct dxmile_type *)						      \
     ((char *) near_fxpart((excase_text)) + sizeof(struct x1f4_leadnode_type)))
#define near_expart(excase_text) \
    ((struct x1f4_nodeline_type *) &near_fxpart((excase_text))->line)

#define near_fxpart(excase_text) \
    ((struct x1f4_leadnode_type *)					      \
     ((char *) (excase_text) - here_offsetof(struct x1f4_leadnode_type, link)))

#define pick_dxpart(fxpart_text) \
    ((struct dxmile_type *)						      \
     ((char *) (fxpart_text) + sizeof(struct x1f4_leadnode_type)))

#define __struct_dxmile_type_alloc_size__ \
    sizeof(struct x1f4_leadnode_type) + 0

typedef struct dxmile_type {
    void *none;
} dxmile_type;

typedef struct lxtext_type {
    int (*copy)(void *, void *, void *, const void *,
		struct x1f4_caselink_type **), (*flat)(void *, void *),
	(*high)(void *, void *, struct x1f4_nodelink_type **),
	(*line)(void *, void *);
    struct x1f4_nodetype_type nodetype[1];
    unsigned trap;
    void *part, *text;
} lxtext_type;

typedef struct lxmile_type {
    struct lxlong_type ever_d;
    struct {
	int (*call)(void *, struct x1f4_nodelink_type *),
	    (*fine)(void *, struct x1f4_nodelink_type **,
		    struct x1f4_nodelink_type *),
	    (*miss)(void *, struct x1f4_nodelink_type **,
		    struct x1f4_nodelink_type *);
	void *text;
    } link_r;
} lxmile_type;

#endif				/* __LIBx1f4_lxmile_types_H__ */
