/*
 * lxnear-inter.h
 * Copyright (C) 2008-2011, 2013-2016, 2018, 2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxnear_inter_H__
#define __LIBx1f4_lxnear_inter_H__

#include <e4.h>
#include <lxnear-types.h>
#include <lxwide.h>

#define _libx1f4i0_lxnear_fini_near	x1f4_fini_lxnear
#define _libx1f4i0_lxnear_fset_near	x1f4_fset_lxnear
#define _libx1f4i0_lxnear_init_near	x1f4_init_lxnear
#define _libx1f4i0_lxnear_tile_near	x1f4_tile_lxnear
#define _libx1f4i0_lxnear_vset_near	x1f4_vset_lxnear

extern int _libx1f4i0_lxnear_b_forward(void *, void *, void **);
extern int _libx1f4i0_lxnear_b_logique(void *, void *, void **);
extern int _libx1f4i0_lxnear_b_pending(void *, void *, void **);
extern int _libx1f4i0_lxnear_b_sequent(void *, void *, void **);
extern int _libx1f4i0_lxnear_c_logique(void *, void *, void **);
extern int _libx1f4i0_lxnear_d_forward(void *, void *, void **);
extern int _libx1f4i0_lxnear_e_forward(void *, void *, void **);
extern int _libx1f4i0_lxnear_e_logique(void *, void *, void **);
extern int _libx1f4i0_lxnear_f_derived(void *, void *, void **);
extern int _libx1f4i0_lxnear_f_forward(void *, void *, void **);
extern int _libx1f4i0_lxnear_f_logique(void *, void *, void **);
extern int _libx1f4i0_lxnear_f_pending(void *, void *, void **);
extern int _libx1f4i0_lxnear_f_sequent(void *, void *, void **);
extern int _libx1f4i0_lxnear_fini_near(void **);
extern int _libx1f4i0_lxnear_fset_near
    (void *, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxnear_g_forward(void *, void *, void **);
extern int _libx1f4i0_lxnear_g_logique(void *, void *, void **);
extern int _libx1f4i0_lxnear_i_logique(void *, void *, void **);
extern int _libx1f4i0_lxnear_init_near
    (void **, unsigned, const struct screen_type *);
extern int _libx1f4i0_lxnear_m_derived(void *, void *, void **);
extern int _libx1f4i0_lxnear_m_forward(void *, void *, void **);
extern int _libx1f4i0_lxnear_m_pending(void *, void *, void **);
extern int _libx1f4i0_lxnear_n_logique(void *, void *, void **);
extern int _libx1f4i0_lxnear_near_fill(struct lxtext_type *, int);
extern int _libx1f4i0_lxnear_p_forward(void *, void *, void **);
extern int _libx1f4i0_lxnear_p_logique(void *, void *, void **);
extern int _libx1f4i0_lxnear_r_derived(void *, void *, void **);
extern int _libx1f4i0_lxnear_r_logique(void *, void *, void **);
extern int _libx1f4i0_lxnear_s_logique(void *, void *, void **);
extern int _libx1f4i0_lxnear_stat_bend(void *, unsigned);
extern int _libx1f4i0_lxnear_stat_dash(void *, unsigned);
extern int _libx1f4i0_lxnear_stat_flat(void *, unsigned, int);
extern int _libx1f4i0_lxnear_stat_lead(void *, int);
extern int _libx1f4i0_lxnear_stat_lift(void *, unsigned, unsigned);
extern int _libx1f4i0_lxnear_stat_lock(void *, unsigned, unsigned);
extern int _libx1f4i0_lxnear_stat_news(void *, int);
extern int _libx1f4i0_lxnear_stat_norm(void *, long);
extern int _libx1f4i0_lxnear_stat_post(void *);
extern int _libx1f4i0_lxnear_stat_text(void *, unsigned);
extern int _libx1f4i0_lxnear_stat_time(void *, unsigned, long);
extern int _libx1f4i0_lxnear_t_logique(void *, void *, void **);
extern int _libx1f4i0_lxnear_tile_near
    (void **, unsigned, struct x1f4_lxwide_type *, unsigned, const void *);
extern int _libx1f4i0_lxnear_vset_near(void *, void **);
extern int _libx1f4i0_lxnear_w_centric(void *, void *, void **);
extern int _libx1f4i0_lxnear_w_derived(void *, void *, void **);
extern int _libx1f4i0_lxnear_w_forward(void *, void *, void **);
extern int _libx1f4i0_lxnear_w_logique(void *, void *, void **);
extern int _libx1f4i0_lxnear_w_nearest(void *, void *, void **);
extern int _libx1f4i0_lxnear_w_pending(void *, void *, void **);
extern int _libx1f4i0_lxnear_w_sequent(void *, void *, void **);
extern int _libx1f4i0_lxnear_x_forward(void *, void *, void **);
extern int _libx1f4i0_lxnear_x_logique(void *, void *, void **);

#endif				/* __LIBx1f4_lxnear_inter_H__ */
