/*
 * lxnova-p.s.c
 * Copyright (C) 2008-2011, 2013, 2014, 2016, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxcall.h>
#include <lxnova.h>

#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxnova_s_pending(void *context, void *output, void **input)
{
    int status;
    struct lxnova_type *lxnova_data;
    void *flat, *text;

    flat = I_USER(input[0]);
    text = I_USER(input[1]);

    lxnova_data = context;

    do {
	if (flat) {
	    status = x1f4_raft_node
		(&lxnova_data->nice_1.east_1.diff_v,
		 &lxnova_data->nice_1.east_1.diff_e,
		 lxnova_data->nice_t.datatype + 1, flat);
	    if (status) {
		break;
	    }
	} else {
	    status = 0;
	}

	lock_lnline(text)->call++;

	l_USER(text, input[0]);
	l_USER(text, output);
    } while (0);

    return status;
}
