/*
 * lxrail-a.j.c
 * Copyright (C) 2017, 2018, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <lxrail-types.h>
#include <progress.h>

int
_libx1f4i0_lxrail_pass_type(void *lxrail, struct x1f4_progress_type **progress,
			    char **copy,
			    const struct x1f4_progress_type *progress_0f,
			    const struct x1f4_progress_type *progress_0b,
			    const struct x1f4_progress_type *progress_1f,
			    const struct x1f4_progress_type *progress_1b,
			    const char *lead_f, const char *lead_b,
			    unsigned read_2, const char *rail_2,
			    unsigned tail_2)
{
    char *text;
    int type;
    struct lxtext_type *lxtext_data;
    struct x1f4_progress_type *progress_data;
    unsigned miss;

    type = ((struct lxrail_type *) lxrail)->link_t.datatype[0].type;

    progress_data = *progress;

    *progress_data = *progress_0f;
    progress_data->type = type;
    progress_data++;

    *progress_data = *progress_0b;
    progress_data->type = type;
    progress_data++;

    text = *copy;

    lxtext_data = ((struct lxrail_type *) lxrail)->link_f.text;

    miss = ((struct lxmiss_type *) lxtext_data - 1)->data.miss;
    for (; miss; miss--) {
	lxtext_data++;

	if (lxtext_data->lxtype.flags & X1f4_LX_TYPE_EXCEPT) {
	} else {
	    unsigned size;

	    size = lxtext_data->lxtype.size;

	    *progress_data = *progress_1f;
	    progress_data->type = type;
	    progress_data->arg2 = lxtext_data->lxtype.code;
	    progress_data->do_clause.size = size + read_2 + tail_2;
	    progress_data->do_clause.text = text;

	    /*
	     * 5 + 16 assumed by -a.i.c
	     */
	    memcpy(text, lead_f, read_2);
	    text += read_2;
	    memcpy(text, lxtext_data->lxtype.name, size);
	    text += size;
	    memcpy(text, rail_2, tail_2);
	    text += tail_2;

	    progress_data++;

	    *progress_data = *progress_1b;
	    progress_data->type = type;
	    progress_data->arg2 = lxtext_data->lxtype.code;
	    progress_data->do_clause.size = size + read_2 + tail_2;
	    progress_data->do_clause.text = text;

	    /*
	     * 5 + 16 assumed by -a.i.c
	     */
	    memcpy(text, lead_b, read_2);
	    text += read_2;
	    memcpy(text, lxtext_data->lxtype.name, size);
	    text += size;
	    memcpy(text, rail_2, tail_2);
	    text += tail_2;

	    progress_data++;
	}
    }

    *progress_data = *progress_1f;
    progress_data->type = type;
    progress_data++;

    *progress_data = *progress_1b;
    progress_data->type = type;
    progress_data++;

    *copy = text;

    *progress = progress_data;

    return 0;
}
