/*
 * lxrail-i.i.c
 * Copyright (C) 2011-2017, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxrail-drive.h>
#include <lxrail-inter.h>
#include <lxrail-types.h>

#define lxrail(rail) \
    ((struct lxrail_type *) (rail))

extern const void *const x1f4_a1_walk_link;

int
_libx1f4i0_lxrail_unto_rail(void *lxrail, void *output, void **input,
			    void **track,
			    struct x1f4_linetext_type *linetext_data,
			    unsigned count,
			    const struct x1f4_function_type *function_text,
			    int lead, int lock, void *dxrail,
			    int (*ever)(struct lxrail_type *,
					struct direct_type *, void *,
					unsigned *))
{
    int status;
    void *beta, **mind;

    status = lxrail(lxrail)->link_v.pick
	(lxrail(lxrail)->link_v.data, &mind, _libx1f4i0_lxrail_slip_poll,
	 sizeof(struct affine_type) + count * sizeof(struct direct_type),
	 &beta);
    if (status) {
	status = _libx1f4i0_lxrail_stat_link(lxrail);
    } else {
	struct affine_type *affine_data;
	struct direct_type *direct_data;

	*mind = beta;

	affine_data = beta;

	direct_data = (void *) (affine_data + 1);

	affine_data->miss = 0;
	affine_data->size = count;

	affine_data->nodelink_data = lock_excase(dxrail);
	affine_data->lxtext_data = lxrail(lxrail)->link_f.text;

	status = ever(lxrail, direct_data, dxrail, &affine_data->miss);
	if (status) {
	} else {
	    if (output == x1f4_a1_walk_link) {
		status = _libx1f4i0_lxrail_lift_call
		    (lxrail, output, input, linetext_data, count,
		     function_text, lead, lock, direct_data);
	    } else {
		status = _libx1f4i0_lxrail_fold_call
		    (lxrail, output, input, linetext_data, count,
		     function_text, lead, lock, direct_data);
	    }
	}
    }

    return status;
}
