/*
 * lxrail-t.x.c
 * Copyright (C) 2008-2014, 2016-2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <lxcall.h>
#include <lxrail-drive.h>
#include <lxrail-inter.h>
#include <lxrail-types.h>

int
_libx1f4i0_lxrail_mark_text(struct lxrail_type *lxrail_data, void *dxrail,
			    int *rank, int *wrap, void *data, void *output)
{
    int status, type;

    type = *rank;
    if (type != X1f4_E4_TEXT) {
	struct x1f4_composer_type *composer_data;

	composer_data = &lxrail_data->link_q;
	if (composer_data->link) {
	    const struct x1f4_linetext_type *linetext_data;

	    status = composer_data->link
		(composer_data->text, X1f4_E4_TEXT, type, &linetext_data);
	    if (status) {
	    } else {
		*rank = X1f4_E4_TEXT;

		status = linetext_data->function.function
		    ((void *) linetext_data->context, output, &data);
		if (status) {
		} else {
		    int link;

		    link = *wrap;
		    if (~link) {
			int (*free)(void *, void *, struct excase_type **,
				    const struct excase_type *);
			struct lxtext_type *lxtext_link;

			lxtext_link = lxrail_data->link_f.text;
			lxtext_link += link;

			*wrap = ~0;

			free = lxtext_link->lxtype.free;
			if (free) {
			    status = free
				(lxtext_link->lxtype.context, I_USER(data),
				 NULL, lock_excase(dxrail));
			}
		    }
		}
	    }
	} else {
	    status = -1;
	}
    } else {
	status = _libx1f4i0_lxcall_pick_text(&lxrail_data->ever_a, data);
	if (status) {
	} else {
	    l_TEXT(I_TEXT(data), output);
	}
    }

    return status;
}

