/*
 * lxssxx-a.x.c
 * Copyright (C) 2008-2010, 2013, 2014, 2016, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <exerrors.h>
#include <lxcall.h>
#include <lxport-types.h>
#include <nl.h>
#include <tcvset.h>

#define lxport(port) \
    ((struct lxport_type *) (port))

#define tccase(vset) \
    ((struct x1f4_tccase_type *) (vset))

int
x1f4_push_ssport(void *lxport, void **copy, void *port,
		 const struct x1f4_nodelink_type *nodelink_data)
{
    int status;

    status = tccase(lock_exlist(port)->text)->miss
	(&lock_exlist(port)->pset, &lock_exlist(port)->text, nodelink_data,
	 (void *) &((struct lxport_type *) lxport)->link_m);
    if (status) {
	status = X1f4_EX_CRITICAL;
    } else {
	do {
	    void *flat;

	    flat = *copy;
	    if (flat) {
		status = x1f4_raft_node
		    (&lxport(lxport)->link_v, &lxport(lxport)->link_e,
		     lxport(lxport)->link_t.datatype + 0, flat);
		if (status) {
		    break;
		}
	    } else {
		status = 0;
	    }

	    *copy = (void *) port;
	} while (0);
    }

    return status;
}
