/*
 * lxvery-a.f.c
 * Copyright (C) 2008-2012, 2015, 2016, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <lxlead.h>
#include <lxvery-inter.h>

int
x1f4_type_lxvery(struct x1f4_nodetype_type *lxtype_data, int crecord3)
{
    lxtype_data->code = crecord3;
    lxtype_data->name = "mint";
    lxtype_data->size = 4;
    lxtype_data->flags =
	X1f4_LX_LINK_ACCESS | X1f4_LX_NULL_RECORD | X1f4_LX_POST_ACCESS;

    lxtype_data->call = x1f4_call_lxlead;
    lxtype_data->copy = x1f4_copy_lxvery;
    lxtype_data->free = x1f4_free_lxvery;
    lxtype_data->lead = x1f4_lead_lxvery;
    lxtype_data->miss = x1f4_near_lxlead;
    lxtype_data->move = NULL;
    lxtype_data->node = x1f4_node_lxvery;
    lxtype_data->post = x1f4_post_lxvery;
    lxtype_data->push = x1f4_push_lxmode;
    lxtype_data->slip = x1f4_slip_lxvery;

    return 0;
}
