/*
 * lxvery-e.w.c
 * Copyright (C) 2008-2016, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <d_fset.h>
#include <lxvery-inter.h>
#include <lxvery-types.h>

#define dxvery(line) \
    ((struct dxvery_type *) (line))

#define lxvery(line) \
    ((struct lxvery_type *) (line))

int
x1f4_slip_lxvery(void *subtext, void **data)
{
    int status;
    unsigned call;
    void *dxvery;

    dxvery = *data;

    call = dxvery(dxvery)->call;
    call--;
    if (call) {
	dxvery(dxvery)->call = call;

	status = 0;
    } else {
	int excess;

	status = _libx1f4i0_lxvery_null_line(subtext, NULL, dxvery);

	excess = _libx1f4i0_flat_lxfset(dxvery(dxvery)->dash);
	if (excess) {
	    status = _libx1f4i0_lxvery_stat_line(subtext, status, excess);
	}

	excess = lxvery(subtext)->link_m.free
	    (lxvery(subtext)->link_m.data, dxvery);
	if (excess) {
	    status = _libx1f4i0_lxvery_stat_free(subtext, status);
	}
    }

    return status;
}
