/*
 * lxvery-l.r.c
 * Copyright (C) 2008-2016, 2018, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxvery-config.h>

#include <stddef.h>

#include <d_fset.h>
#include <e4.h>
#include <lxvery-drive.h>
#include <lxvery-inter.h>
#include <lxvery-types.h>

int
_libx1f4i0_lxvery_r_logique(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE very;
    int status;
    struct dxvery_type *dxvery_data;
    struct lxvery_type *lxvery_data;
    void *dash;

    dxvery_data = I_LINE(input[0]);

    lxvery_data = context;

    dash = dxvery_data->dash;

    very = I_MODE(input[1]);
#if __VERY_PSET__
    very += ~(X1f4_E4_C_BILL) 0 >> 1;
#endif				/* __VERY_PSET__ */

    status = _libx1f4i0_cast_lxfset(dash, &very);
    if (status) {
	if (status == X1f4_BQFSET_MISS_CLASS) {
	    status = 0;

	    l_LINE(dxvery_data, output);
	} else {
	    status = _libx1f4i0_lxvery_stat_line(lxvery_data, 0, status);
	}
    } else {
	dxvery_data->size--;

	l_LINE(dxvery_data, output);
    }

    return status;
}
