/*
 * qscc.4.c
 * Copyright (C) 2010-2011, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qscc-defs.h>
#include <qscc-names.h>
#include <qscc-patch.h>
#include <qscc-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

#define qsrate(qsrate)			((struct qsrate_type *) (qsrate))

int
x1f4_peek_qsrate(void *qsrate, unsigned index, void **peek)
{
    int status;
    unsigned count;

    count = qsrate(qsrate)->link_a.fplist.size;

    if (!(index < count)) {
	status = DECK_ERROR;
    } else {
	unsigned rate;
	void *node;

	node = qsrate(qsrate)->link_a.fplist.fpnode;

	status = 0;

	rate = qsrate(qsrate)->link_a.fplist.rate;

	if (rate) {
	    struct fpnode_type *fpnode_data;
	    unsigned lock;

	    fpnode_data = node;

	    lock = qsrate(qsrate)->link_a.fplist.lock;

	    do {
		Progress_node(fpnode_data, lock);

		fpnode_data = fpnode_data->star;

		rate--;
	    } while (rate);

	    node = fpnode_data;
	}

	*peek = M_TEXT(node, index * qsrate(qsrate)->link_a.fplist.mall);
    }

    return status;
}
